Whamcloud - gitweb
LU-9498 osp: revert till a fix
[fs/lustre-release.git] / lustre / tests / recovery-small.sh
1 #!/bin/bash
2
3 set -e
4
5 #         bug  5493  LU2034
6 ALWAYS_EXCEPT="52    60      $RECOVERY_SMALL_EXCEPT"
7
8 export MULTIOP=${MULTIOP:-multiop}
9 PTLDEBUG=${PTLDEBUG:--1}
10 LUSTRE=${LUSTRE:-`dirname $0`/..}
11 . $LUSTRE/tests/test-framework.sh
12 init_test_env $@
13 . ${CONFIG:=$LUSTRE/tests/cfg/$NAME.sh}
14 init_logging
15
16 require_dsh_mds || exit 0
17
18 # also long tests: 19, 21a, 21e, 21f, 23, 27
19
20 [ "$SLOW" = "no" ] && EXCEPT_SLOW=""
21
22 build_test_filter
23
24 # Allow us to override the setup if we already have a mounted system by
25 # setting SETUP=" " and CLEANUP=" "
26 SETUP=${SETUP:-""}
27 CLEANUP=${CLEANUP:-""}
28
29 check_and_setup_lustre
30
31 assert_DIR
32 rm -rf $DIR/d[0-9]* $DIR/f.${TESTSUITE}*
33
34 test_1() {
35         local f1="$DIR/$tfile"
36         local f2="$DIR/$tfile.2"
37
38         drop_request "mcreate $f1" ||
39                 error_noexit "create '$f1': drop req"
40
41         drop_reint_reply "mcreate $f2" ||
42                 error_noexit "create '$f2': drop rep"
43
44         drop_request "tchmod 111 $f2" ||
45                 error_noexit "chmod '$f2': drop req"
46
47         drop_reint_reply "tchmod 666 $f2" ||
48                 error_noexit "chmod '$f2': drop rep"
49
50         drop_request "statone $f2" ||
51                 error_noexit "stat '$f2': drop req"
52
53         drop_reply  "statone $f2" ||
54                 error_noexit "stat '$f2': drop rep"
55 }
56 run_test 1 "create, chmod, stat: drop req, drop rep"
57
58 test_4() {
59         local t=$DIR/$tfile
60         do_facet_create_file client $t 10K ||
61                 error_noexit "Create file $t"
62
63         drop_request "cat $t > /dev/null" ||
64                 error_noexit "Open request for $t file"
65
66         drop_reply "cat $t > /dev/null" ||
67                 error_noexit "Open replay for $t file"
68 }
69 run_test 4 "open: drop req, drop rep"
70
71 test_5() {
72         local T=$DIR/$tfile
73         local R="$T-renamed"
74         local RR="$T-renamed-again"
75         do_facet_create_file client $T 10K ||
76                 error_noexit "Create file $T"
77
78         drop_request "mv $T $R" ||
79                 error_noexit "Rename $T"
80
81         drop_reint_reply "mv $R $RR" ||
82                 error_noexit "Failed rename replay on $R"
83
84         do_facet client "checkstat -v $RR" ||
85                 error_noexit "checkstat error on $RR"
86
87         do_facet client "rm $RR" ||
88                 error_noexit "Can't remove file $RR"
89 }
90 run_test 5 "rename: drop req, drop rep"
91
92 test_6() {
93         local T=$DIR/$tfile
94         local LINK1=$DIR/$tfile.link1
95         local LINK2=$DIR/$tfile.link2
96
97         do_facet_create_file client $T 10K ||
98                 error_noexit "Create file $T"
99
100         drop_request "mlink $T $LINK1" ||
101                 error_noexit "mlink request for $T"
102
103         drop_reint_reply "mlink $T $LINK2" ||
104                 error_noexit "mlink reply for $T"
105
106         drop_request "munlink $LINK1" ||
107                 error_noexit "munlink request for $T"
108
109         drop_reint_reply "munlink $LINK2" ||
110                 error_noexit "munlink reply for $T"
111
112         do_facet client "rm $T" ||
113                 error_noexit "Can't remove file $T"
114 }
115 run_test 6 "link, unlink: drop req, drop rep"
116
117 #bug 1423
118 test_8() {
119     drop_reint_reply "touch $DIR/$tfile"    || return 1
120 }
121 run_test 8 "touch: drop rep (bug 1423)"
122
123 #bug 1420
124 test_9() {
125         remote_ost_nodsh && skip "remote OST with nodsh" && return 0
126
127         local t1=${tfile}.1
128         local t2=${tfile}.2
129         do_facet_random_file client $TMP/$tfile 1K ||
130                 error_noexit "Create random file $TMP/$tfile"
131         # make this big, else test 9 doesn't wait for bulk -- bz 5595
132         do_facet_create_file client $TMP/$t1 4M ||
133                 error_noexit "Create file $TMP/$t1"
134         do_facet client "cp $TMP/$t1 $DIR/$t1" ||
135                 error_noexit "Can't copy to $DIR/$t1 file"
136         pause_bulk "cp $TMP/$tfile $DIR/$tfile" ||
137                 error_noexit "Can't pause_bulk copy"
138         do_facet client "cp $TMP/$t1 $DIR/$t2" ||
139                 error_noexit "Can't copy file"
140         do_facet client "sync"
141         do_facet client "rm $DIR/$tfile $DIR/$t2 $DIR/$t1" ||
142                 error_noexit "Can't remove files"
143         do_facet client "rm $TMP/$t1 $TMP/$tfile"
144 }
145 run_test 9 "pause bulk on OST (bug 1420)"
146
147 #bug 1521
148 test_10a() {
149         local before=$(date +%s)
150         local evict
151
152         do_facet client "stat $DIR > /dev/null"  ||
153                 error "failed to stat $DIR: $?"
154         drop_bl_callback "chmod 0777 $DIR" ||
155                 error "failed to chmod $DIR: $?"
156
157         # let the client reconnect
158         client_reconnect
159         evict=$(do_facet client $LCTL get_param mdc.$FSNAME-MDT*.state |
160           awk -F"[ [,]" '/EVICTED ]$/ { if (mx<$5) {mx=$5;} } END { print mx }')
161         [ ! -z "$evict" ] && [[ $evict -gt $before ]] ||
162                 (do_facet client $LCTL get_param mdc.$FSNAME-MDT*.state;
163                     error "no eviction: $evict before:$before")
164
165         do_facet client checkstat -v -p 0777 $DIR ||
166                 error "client checkstat failed: $?"
167 }
168 run_test 10a "finish request on server after client eviction (bug 1521)"
169
170 test_10b() {
171         local before=$(date +%s)
172         local evict
173
174         [[ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.6.53) ]] &&
175                 skip "Need MDS version at least 2.6.53" && return
176         do_facet client "stat $DIR > /dev/null"  ||
177                 error "failed to stat $DIR: $?"
178         drop_bl_callback_once "chmod 0777 $DIR" ||
179                 error "failed to chmod $DIR: $?"
180
181         # let the client reconnect
182         client_reconnect
183         evict=$(do_facet client $LCTL get_param mdc.$FSNAME-MDT*.state |
184           awk -F"[ [,]" '/EVICTED ]$/ { if (mx<$5) {mx=$5;} } END { print mx }')
185
186         [ -z "$evict" ] || [[ $evict -le $before ]] ||
187                 (do_facet client $LCTL get_param mdc.$FSNAME-MDT*.state;
188                     error "eviction happened: $evict before:$before")
189
190         do_facet client checkstat -v -p 0777 $DIR ||
191                 error "client checkstat failed: $?"
192 }
193 run_test 10b "re-send BL AST"
194
195 test_10c() {
196         local before=$(date +%s)
197         local evict
198         local mdccli
199         local mdcpath
200         local conn_uuid
201         local workdir
202         local pid
203         local rc
204
205         workdir="${DIR}/${tdir}"
206         mkdir -p ${workdir} || error "can't create workdir $?"
207         stat ${workdir} > /dev/null ||
208                 error "failed to stat ${workdir}: $?"
209         mdtidx=$($LFS getdirstripe -i ${workdir})
210         mdtname=$($LFS mdts ${workdir} | grep -e "^$mdtidx:" |
211                   awk '{sub("_UUID", "", $2); print $2;}')
212         #assume one client
213         mdccli=$($LCTL dl | grep "${mdtname}-mdc" | awk '{print $4;}')
214         conn_uuid=$($LCTL get_param -n mdc.${mdccli}.mds_conn_uuid)
215         mdcpath="mdc.${mdccli}.import=connection=${conn_uuid}"
216
217         drop_bl_callback_once "chmod 0777 ${workdir}" &
218         pid=$!
219
220         # let chmod blocked
221         sleep 1
222         # force client reconnect
223         $LCTL set_param "${mdcpath}"
224
225         # wait client reconnect
226         client_reconnect
227         wait $pid
228         rc=$?
229         evict=$($LCTL get_param mdc.${mdccli}.state |
230            awk -F"[ [,]" '/EVICTED]$/ { if (t<$4) {t=$4;} } END { print t }')
231
232         [[ $evict -le $before ]] ||
233                 ( $LCTL get_param mdc.$FSNAME-MDT*.state;
234                     error "eviction happened: $EVICT before:$BEFORE" )
235
236         [ $rc -eq 0 ] || error "chmod must finished OK"
237         checkstat -v -p 0777 "${workdir}" ||
238                 error "client checkstat failed: $?"
239 }
240 run_test 10c "re-send BL AST vs reconnect race (LU-5569)"
241
242 test_10d() {
243         local before=$(date +%s)
244         local evict
245
246         [[ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.6.90) ]] &&
247                 skip "Need MDS version at least 2.6.90" && return
248
249         # sleep 1 is to make sure that BEFORE is not equal to EVICTED below
250         sleep 1
251         rm -f $TMP/$tfile
252         echo -n ", world" | dd of=$TMP/$tfile bs=1c seek=5
253
254         remount_client $MOUNT
255         mount_client $MOUNT2
256
257         cancel_lru_locks osc
258         $LFS setstripe -i 0 -c 1 $DIR1/$tfile
259         echo -n hello | dd of=$DIR1/$tfile bs=5
260
261         stat $DIR2/$tfile >& /dev/null
262         $LCTL set_param fail_err=71
263         drop_bl_callback "echo -n \\\", world\\\" >> $DIR2/$tfile"
264
265         client_reconnect
266
267         cancel_lru_locks osc
268         cmp -l $DIR1/$tfile $DIR2/$tfile || error "file contents differ"
269         cmp -l $DIR1/$tfile $TMP/$tfile || error "wrong content found"
270
271         evict=$(do_facet client $LCTL get_param osc.$FSNAME-OST0000*.state | \
272                 tr -d '\-\[\] ' | \
273           awk -F"[ [,]" '/EVICTED$/ { if (mx<$1) {mx=$1;} } END { print mx }')
274
275         [[ $evict -gt $before ]] ||
276                 (do_facet client $LCTL get_param osc.$FSNAME-OST0000*.state;
277                     error "no eviction: $evict before:$before")
278
279         $LCTL set_param fail_err=0
280         rm $TMP/$tfile
281         umount_client $MOUNT2
282 }
283 run_test 10d "test failed blocking ast"
284
285 test_10e()
286 {
287         [[ $(lustre_version_code ost1) -le $(version_code 2.8.58) ]] &&
288                 skip "Need OST version at least 2.8.59" && return 0
289         [ $CLIENTCOUNT -lt 2 ] && skip "need two clients" && return 0
290         [ $(facet_host client) == $(facet_host ost1) ] &&
291                 skip "need ost1 and client on different nodes" && return 0
292         local -a clients=(${CLIENTS//,/ })
293         local client1=${clients[0]}
294         local client2=${clients[1]}
295
296         $LFS setstripe -c 1 -i 0 $DIR/$tfile-1 $DIR/$tfile-2
297         $MULTIOP $DIR/$tfile-1 Ow1048576c
298
299 #define OBD_FAIL_LDLM_BL_CALLBACK_NET                   0x305
300         $LCTL set_param fail_loc=0x80000305
301
302 #define OBD_FAIL_LDLM_ENQUEUE_OLD_EXPORT 0x30e
303         do_facet ost1 "$LCTL set_param fail_loc=0x1000030e"
304         # hit OBD_FAIL_LDLM_ENQUEUE_OLD_EXPORT twice:
305         # 1. to return ENOTCONN from ldlm_handle_enqueue0
306         # 2. to pause reconnect handling between resend and setting
307         # import to LUSTRE_IMP_FULL state
308         do_facet ost1 "$LCTL set_param fail_val=3"
309
310         # client1 fails ro respond to bl ast
311         do_node $client2 "$MULTIOP $DIR/$tfile-1 Ow1048576c" &
312         MULTIPID=$!
313
314         # ost1 returns error on enqueue, which causes client1 to reconnect
315         do_node $client1 "$MULTIOP $DIR/$tfile-2 Ow1048576c" ||
316                 error "multiop failed"
317         wait $MULTIPID
318
319         do_facet ost1 "$LCTL set_param fail_loc=0"
320         do_facet ost1 "$LCTL set_param fail_val=0"
321 }
322 run_test 10e "re-send BL AST vs reconnect race 2"
323
324 #bug 2460
325 # wake up a thread waiting for completion after eviction
326 test_11(){
327         do_facet client $MULTIOP $DIR/$tfile Ow  ||
328                 { error "multiop write failed: $?"; return 1; }
329         do_facet client $MULTIOP $DIR/$tfile or  ||
330                 { error "multiop read failed: $?"; return 2; }
331
332         cancel_lru_locks osc
333
334         do_facet client $MULTIOP $DIR/$tfile or  ||
335                 { error "multiop read failed: $?"; return 3; }
336         drop_bl_callback_once $MULTIOP $DIR/$tfile Ow ||
337                 echo "evicted as expected"
338
339         do_facet client munlink $DIR/$tfile ||
340                 { error "munlink failed: $?"; return 4; }
341         # allow recovery to complete
342         client_up || client_up || sleep $TIMEOUT
343 }
344 run_test 11 "wake up a thread waiting for completion after eviction (b=2460)"
345
346 #b=2494
347 test_12(){
348         $LCTL mark $MULTIOP $DIR/$tfile OS_c
349         do_facet $SINGLEMDS "lctl set_param fail_loc=0x115"
350         clear_failloc $SINGLEMDS $((TIMEOUT * 2)) &
351         multiop_bg_pause $DIR/$tfile OS_c ||
352                 { error "multiop failed: $?"; return 1; }
353         PID=$!
354 #define OBD_FAIL_MDS_CLOSE_NET           0x115
355         kill -USR1 $PID
356         echo "waiting for multiop $PID"
357         wait $PID || { error "wait for multiop faile: $?"; return 2; }
358         do_facet client munlink $DIR/$tfile ||
359                 { error "client munlink failed: $?"; return 3; }
360         # allow recovery to complete
361         client_up || client_up || sleep $TIMEOUT
362 }
363 run_test 12 "recover from timed out resend in ptlrpcd (b=2494)"
364
365 # Bug 113, check that readdir lost recv timeout works.
366 test_13() {
367         mkdir -p $DIR/$tdir || { error "mkdir failed: $?"; return 1; }
368         touch $DIR/$tdir/newentry || { error "touch failed: $?"; return 2; }
369 # OBD_FAIL_MDS_READPAGE_NET|OBD_FAIL_ONCE
370         do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000104"
371         ls $DIR/$tdir || { error "ls failed: $?"; return 3; }
372         do_facet $SINGLEMDS "lctl set_param fail_loc=0"
373         rm -rf $DIR/$tdir || { error "remove test dir failed: $?"; return 4; }
374 }
375 run_test 13 "mdc_readpage restart test (bug 1138)"
376
377 # Bug 113, check that readdir lost send timeout works.
378 test_14() {
379     mkdir -p $DIR/$tdir
380     touch $DIR/$tdir/newentry
381 # OBD_FAIL_MDS_SENDPAGE|OBD_FAIL_ONCE
382     do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000106"
383     ls $DIR/$tdir || return 1
384     do_facet $SINGLEMDS "lctl set_param fail_loc=0"
385 }
386 run_test 14 "mdc_readpage resend test (bug 1138)"
387
388 test_15() {
389     do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000128"
390     touch $DIR/$tfile && return 1
391     return 0
392 }
393 run_test 15 "failed open (-ENOMEM)"
394
395 READ_AHEAD=`lctl get_param -n llite.*.max_read_ahead_mb | head -n 1`
396 stop_read_ahead() {
397    lctl set_param -n llite.*.max_read_ahead_mb 0
398 }
399
400 start_read_ahead() {
401    lctl set_param -n llite.*.max_read_ahead_mb $READ_AHEAD
402 }
403
404 test_16() {
405         remote_ost_nodsh && skip "remote OST with nodsh" && return 0
406
407         do_facet_random_file client $TMP/$tfile 100K ||
408                 { error_noexit "Create random file $TMP/$T" ; return 0; }
409         do_facet client "cp $TMP/$tfile $DIR/$tfile" ||
410                 { error_noexit "Copy to $DIR/$tfile file" ; return 0; }
411         sync
412         stop_read_ahead
413
414 #define OBD_FAIL_PTLRPC_BULK_PUT_NET 0x504 | OBD_FAIL_ONCE
415         do_facet ost1 "lctl set_param fail_loc=0x80000504"
416         cancel_lru_locks osc
417         # OST bulk will time out here, client resends
418         do_facet client "cmp $TMP/$tfile $DIR/$tfile" || return 1
419         do_facet ost1 lctl set_param fail_loc=0
420         # give recovery a chance to finish (shouldn't take long)
421         sleep $TIMEOUT
422         do_facet client "cmp $TMP/$tfile $DIR/$tfile" || return 2
423         start_read_ahead
424         rm -f $TMP/$tfile
425 }
426 run_test 16 "timeout bulk put, don't evict client (2732)"
427
428 test_17a() {
429     local at_max_saved=0
430
431     remote_ost_nodsh && skip "remote OST with nodsh" && return 0
432
433         local SAMPLE_FILE=$TMP/$tfile
434         do_facet_random_file client $SAMPLE_FILE 20K ||
435                 { error_noexit "Create random file $SAMPLE_FILE" ; return 0; }
436
437     # With adaptive timeouts, bulk_get won't expire until adaptive_timeout_max
438     if at_is_enabled; then
439         at_max_saved=$(at_max_get ost1)
440         at_max_set $TIMEOUT ost1
441     fi
442
443     # OBD_FAIL_PTLRPC_BULK_GET_NET 0x0503 | OBD_FAIL_ONCE
444     # OST bulk will time out here, client retries
445     do_facet ost1 lctl set_param fail_loc=0x80000503
446     # need to ensure we send an RPC
447     do_facet client cp $SAMPLE_FILE $DIR/$tfile
448     sync
449
450     # with AT, client will wait adaptive_max*factor+net_latency before
451     # expiring the req, hopefully timeout*2 is enough
452     sleep $(($TIMEOUT*2))
453
454     do_facet ost1 lctl set_param fail_loc=0
455     do_facet client "df $DIR"
456     # expect cmp to succeed, client resent bulk
457     do_facet client "cmp $SAMPLE_FILE $DIR/$tfile" || return 3
458     do_facet client "rm $DIR/$tfile" || return 4
459     [ $at_max_saved -ne 0 ] && at_max_set $at_max_saved ost1
460     return 0
461 }
462 run_test 17a "timeout bulk get, don't evict client (2732)"
463
464 test_17b() {
465         [ -z "$RCLIENTS" ] && skip "Needs multiple clients" && return 0
466
467         # get one of the clients from client list
468         local rcli=$(echo $RCLIENTS | cut -d ' ' -f 1)
469         local p="$TMP/$TESTSUITE-$TESTNAME.parameters"
470         local ldlm_enqueue_min=$(do_facet ost1 find /sys -name ldlm_enqueue_min)
471         [ -z "$ldlm_enqueue_min" ] &&
472                 skip "missing /sys/.../ldlm_enqueue_min" && return 0
473
474         $LFS setstripe -i 0 -c 1 -S 1048576 $DIR/$tfile ||
475                 error "setstripe failed"
476         $LFS setstripe -i 0 -c 1 -S 1048576 $DIR/${tfile}2 ||
477                 error "setstripe 2 failed"
478
479         save_lustre_params ost1 "at_history" > $p
480         save_lustre_params ost1 "bulk_timeout" >> $p
481         local dev="${FSNAME}-OST0000"
482         save_lustre_params ost1 "obdfilter.$dev.brw_size" >> $p
483         local ldlm_enqueue_min_save=$(do_facet ost1 cat $ldlm_enqueue_min)
484
485         local new_at_history=15
486
487         do_facet ost1 "$LCTL set_param at_history=$new_at_history"
488         do_facet ost1 "$LCTL set_param bulk_timeout=30"
489         do_facet ost1 "echo 30 > /sys/module/ptlrpc/parameters/ldlm_enqueue_min"
490
491         # brw_size is required to be 4m so that bulk transfer timeout
492         # could be simulated with OBD_FAIL_PTLRPC_CLIENT_BULK_CB3
493         local brw_size=$($LCTL get_param -n \
494             osc.$FSNAME-OST0000-osc-[^M]*.import |
495             awk '/max_brw_size/{print $2}')
496         if [ $brw_size -ne 4194304 ]
497         then
498                 save_lustre_params ost1 "obdfilter.$dev.brw_size" >> $p
499                 do_facet ost1 "$LCTL set_param obdfilter.$dev.brw_size=4"
500                 remount_client $MOUNT
501         fi
502
503         # get service estimate expanded
504         #define OBD_FAIL_OST_BRW_PAUSE_PACK              0x224
505         do_facet ost1 "$LCTL set_param fail_loc=0x80000224 fail_val=35"
506         echo "delay rpc servicing by 35 seconds"
507         dd if=/dev/zero of=$DIR/$tfile bs=1M count=1 conv=fdatasync
508
509         local estimate
510         estimate=$($LCTL get_param -n osc.$dev-osc-*.timeouts |
511             awk '/portal 6/ {print $5}')
512         echo "service estimates increased to $estimate"
513
514         # let current worst service estimate to get closer to obliteration
515         sleep $((new_at_history / 3))
516
517         # start i/o and simulate bulk transfer loss
518         #define OBD_FAIL_PTLRPC_CLIENT_BULK_CB3     0x520
519         do_facet ost1 "$LCTL set_param fail_loc=0xa0000520 fail_val=1"
520         dd if=/dev/zero of=$DIR/$tfile bs=2M count=1 conv=fdatasync,notrunc &
521         local writedd=$!
522
523         # start lock conflict handling
524         sleep $((new_at_history / 3))
525         do_node $rcli "dd if=$DIR/$tfile of=/dev/null bs=1M count=1" &
526         local readdd=$!
527
528         # obliterate the worst service estimate
529         sleep $((new_at_history / 3 + 1))
530         dd if=/dev/zero of=$DIR/${tfile}2 bs=1M count=1
531
532         estimate=$($LCTL get_param -n osc.$dev-osc-*.timeouts |
533             awk '/portal 6/ {print $5}')
534         echo "service estimate dropped to $estimate"
535
536         wait $writedd
537         [[ $? == 0 ]] || error "write failed"
538         wait $readdd
539         [[ $? == 0 ]] || error "read failed"
540
541         restore_lustre_params <$p
542         if [ $brw_size -ne 4194304 ]
543         then
544                 remount_client $MOUNT || error "remount_client failed"
545         fi
546         do_facet ost1 "echo $ldlm_enqueue_min_save > $ldlm_enqueue_min"
547 }
548 run_test 17b "timeout bulk get, dont evict client (3582)"
549
550 test_18a() {
551     [ -z ${ost2_svc} ] && skip_env "needs 2 osts" && return 0
552
553         do_facet_create_file client $TMP/$tfile 20K ||
554                 { error_noexit "Create file $TMP/$tfile" ; return 0; }
555
556     do_facet client mkdir -p $DIR/$tdir
557     f=$DIR/$tdir/$tfile
558
559     cancel_lru_locks osc
560     pgcache_empty || return 1
561
562     # 1 stripe on ost2
563     $LFS setstripe -i 1 -c 1 $f
564     stripe_index=$($LFS getstripe -i $f)
565     if [ $stripe_index -ne 1 ]; then
566         $LFS getstripe $f
567         error "$f: stripe_index $stripe_index != 1" && return
568     fi
569
570     do_facet client cp $TMP/$tfile $f
571     sync
572     local osc2dev=`lctl get_param -n devices | grep ${ost2_svc}-osc- | egrep -v 'MDT' | awk '{print $1}'`
573     $LCTL --device $osc2dev deactivate || return 3
574     # my understanding is that there should be nothing in the page
575     # cache after the client reconnects?     
576     rc=0
577     pgcache_empty || rc=2
578     $LCTL --device $osc2dev activate
579     rm -f $f $TMP/$tfile
580     return $rc
581 }
582 run_test 18a "manual ost invalidate clears page cache immediately"
583
584 test_18b() {
585     remote_ost_nodsh && skip "remote OST with nodsh" && return 0
586
587         do_facet_create_file client $TMP/$tfile 20K ||
588                 { error_noexit "Create file $TMP/$tfile" ; return 0; }
589
590     do_facet client mkdir -p $DIR/$tdir
591     f=$DIR/$tdir/$tfile
592
593     cancel_lru_locks osc
594     pgcache_empty || return 1
595
596     $LFS setstripe -i 0 -c 1 $f
597     stripe_index=$($LFS getstripe -i $f)
598     if [ $stripe_index -ne 0 ]; then
599         $LFS getstripe $f
600         error "$f: stripe_index $stripe_index != 0" && return
601     fi
602
603     do_facet client cp $TMP/$tfile $f
604     sync
605     ost_evict_client
606     # allow recovery to complete
607     sleep $((TIMEOUT + 2))
608     # my understanding is that there should be nothing in the page
609     # cache after the client reconnects?     
610     rc=0
611     pgcache_empty || rc=2
612     rm -f $f $TMP/$tfile
613     return $rc
614 }
615 run_test 18b "eviction and reconnect clears page cache (2766)"
616
617 test_18c() {
618     remote_ost_nodsh && skip "remote OST with nodsh" && return 0
619
620         do_facet_create_file client $TMP/$tfile 20K ||
621                 { error_noexit "Create file $TMP/$tfile" ; return 0; }
622
623     do_facet client mkdir -p $DIR/$tdir
624     f=$DIR/$tdir/$tfile
625
626     cancel_lru_locks osc
627     pgcache_empty || return 1
628
629     $LFS setstripe -i 0 -c 1 $f
630     stripe_index=$($LFS getstripe -i $f)
631     if [ $stripe_index -ne 0 ]; then
632         $LFS getstripe $f
633         error "$f: stripe_index $stripe_index != 0" && return
634     fi
635
636     do_facet client cp $TMP/$tfile $f
637     sync
638     ost_evict_client
639
640     # OBD_FAIL_OST_CONNECT_NET2
641     # lost reply to connect request
642     do_facet ost1 lctl set_param fail_loc=0x80000225
643     # force reconnect
644     sleep 1
645     $LFS df $MOUNT > /dev/null 2>&1
646     sleep 2
647     # my understanding is that there should be nothing in the page
648     # cache after the client reconnects?
649     rc=0
650     pgcache_empty || rc=2
651     rm -f $f $TMP/$tfile
652     return $rc
653 }
654 run_test 18c "Dropped connect reply after eviction handing (14755)"
655
656 test_19a() {
657         local BEFORE=`date +%s`
658         local EVICT
659
660         mount_client $DIR2 || error "failed to mount $DIR2"
661
662         # cancel cached locks from OST to avoid eviction from it
663         cancel_lru_locks osc
664
665         do_facet client "stat $DIR > /dev/null"  ||
666                 error "failed to stat $DIR: $?"
667         drop_ldlm_cancel "chmod 0777 $DIR2" ||
668                 error "failed to chmod $DIR2"
669
670         umount_client $DIR2
671
672         # let the client reconnect
673         client_reconnect
674         EVICT=$(do_facet client $LCTL get_param mdc.$FSNAME-MDT*.state |
675                 awk -F"[ [,]" '/EVICTED ]$/ \
676                         { if (mx<$5) {mx=$5;} } END { print mx }')
677
678         [ ! -z "$EVICT" ] && [[ $EVICT -gt $BEFORE ]] ||
679                 (do_facet client $LCTL get_param mdc.$FSNAME-MDT*.state;
680                     error "no eviction: $EVICT before:$BEFORE")
681 }
682 run_test 19a "test expired_lock_main on mds (2867)"
683
684 test_19b() {
685         local BEFORE=`date +%s`
686         local EVICT
687
688         mount_client $DIR2 || error "failed to mount $DIR2: $?"
689
690         # cancel cached locks from MDT to avoid eviction from it
691         cancel_lru_locks mdc
692
693         do_facet client $MULTIOP $DIR/$tfile Ow ||
694                 error "failed to run multiop: $?"
695         drop_ldlm_cancel $MULTIOP $DIR2/$tfile Ow ||
696                 error "failed to ldlm_cancel: $?"
697
698         umount_client $DIR2 || error "failed to unmount $DIR2: $?"
699         do_facet client munlink $DIR/$tfile ||
700                 error "failed to unlink $DIR/$tfile: $?"
701
702         # let the client reconnect
703         client_reconnect
704         EVICT=$(do_facet client $LCTL get_param osc.$FSNAME-OST*.state |
705                 awk -F"[ [,]" '/EVICTED ]$/ \
706                         { if (mx < $5) {mx = $5;} } END { print mx }')
707
708         [ ! -z "$EVICT" ] && [[ $EVICT -gt $BEFORE ]] ||
709                 (do_facet client $LCTL get_param osc.$FSNAME-OST*.state;
710                     error "no eviction: $EVICT before:$BEFORE")
711 }
712 run_test 19b "test expired_lock_main on ost (2867)"
713
714 test_19c() {
715         local BEFORE=`date +%s`
716
717         mount_client $DIR2
718         $LCTL set_param ldlm.namespaces.*.early_lock_cancel=0
719
720         mkdir -p $DIR1/$tfile
721         stat $DIR1/$tfile
722
723 #define OBD_FAIL_PTLRPC_CANCEL_RESEND 0x516
724         do_facet mds $LCTL set_param fail_loc=0x80000516
725
726         touch $DIR2/$tfile/file1 &
727         PID1=$!
728         # let touch to get blocked on the server
729         sleep 2
730
731         wait $PID1
732         $LCTL set_param ldlm.namespaces.*.early_lock_cancel=1
733         umount_client $DIR2
734
735         # let the client reconnect
736         sleep 5
737         EVICT=$(do_facet client $LCTL get_param mdc.$FSNAME-MDT*.state |
738           awk -F"[ [,]" '/EVICTED ]$/ { if (mx<$5) {mx=$5;} } END { print mx }')
739
740         [ -z "$EVICT" ] || [[ $EVICT -le $BEFORE ]] || error "eviction happened"
741 }
742 run_test 19c "check reconnect and lock resend do not trigger expired_lock_main"
743
744 test_20a() {    # bug 2983 - ldlm_handle_enqueue cleanup
745         remote_ost_nodsh && skip "remote OST with nodsh" && return 0
746
747         mkdir -p $DIR/$tdir
748         $LFS setstripe -i 0 -c 1 $DIR/$tdir/${tfile}
749         multiop_bg_pause $DIR/$tdir/${tfile} O_wc || return 1
750         MULTI_PID=$!
751         cancel_lru_locks osc
752 #define OBD_FAIL_LDLM_ENQUEUE_EXTENT_ERR 0x308
753         do_facet ost1 lctl set_param fail_loc=0x80000308
754         kill -USR1 $MULTI_PID
755         wait $MULTI_PID
756         rc=$?
757         [ $rc -eq 0 ] && error "multiop didn't fail enqueue: rc $rc" || true
758 }
759 run_test 20a "ldlm_handle_enqueue error (should return error)" 
760
761 test_20b() {    # bug 2986 - ldlm_handle_enqueue error during open
762         remote_ost_nodsh && skip "remote OST with nodsh" && return 0
763
764         mkdir -p $DIR/$tdir
765         $LFS setstripe -i 0 -c 1 $DIR/$tdir/${tfile}
766         cancel_lru_locks osc
767 #define OBD_FAIL_LDLM_ENQUEUE_EXTENT_ERR 0x308
768         do_facet ost1 lctl set_param fail_loc=0x80000308
769         dd if=/etc/hosts of=$DIR/$tdir/$tfile && \
770                 error "didn't fail open enqueue" || true
771 }
772 run_test 20b "ldlm_handle_enqueue error (should return error)"
773
774 test_21a() {
775        mkdir -p $DIR/$tdir-1
776        mkdir -p $DIR/$tdir-2
777        multiop_bg_pause $DIR/$tdir-1/f O_c || return 1
778        close_pid=$!
779
780        do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000129"
781        $MULTIOP $DIR/$tdir-2/f Oc &
782        open_pid=$!
783        sleep 1
784        do_facet $SINGLEMDS "lctl set_param fail_loc=0"
785
786        do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000115"
787        kill -USR1 $close_pid
788        cancel_lru_locks mdc
789        wait $close_pid || return 1
790        wait $open_pid || return 2
791        do_facet $SINGLEMDS "lctl set_param fail_loc=0"
792
793        $CHECKSTAT -t file $DIR/$tdir-1/f || return 3
794        $CHECKSTAT -t file $DIR/$tdir-2/f || return 4
795
796        rm -rf $DIR/$tdir-*
797 }
798 run_test 21a "drop close request while close and open are both in flight"
799
800 test_21b() {
801        mkdir -p $DIR/$tdir-1
802        mkdir -p $DIR/$tdir-2
803        multiop_bg_pause $DIR/$tdir-1/f O_c || return 1
804        close_pid=$!
805
806        do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000107"
807        mcreate $DIR/$tdir-2/f &
808        open_pid=$!
809        sleep 1
810        do_facet $SINGLEMDS "lctl set_param fail_loc=0"
811
812        kill -USR1 $close_pid
813        cancel_lru_locks mdc
814        wait $close_pid || return 1
815        wait $open_pid || return 3
816
817        $CHECKSTAT -t file $DIR/$tdir-1/f || return 4
818        $CHECKSTAT -t file $DIR/$tdir-2/f || return 5
819        rm -rf $DIR/$tdir-*
820 }
821 run_test 21b "drop open request while close and open are both in flight"
822
823 test_21c() {
824        mkdir -p $DIR/$tdir-1
825        mkdir -p $DIR/$tdir-2
826        multiop_bg_pause $DIR/$tdir-1/f O_c || return 1
827        close_pid=$!
828
829        do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000107"
830        mcreate $DIR/$tdir-2/f &
831        open_pid=$!
832        sleep 3
833        do_facet $SINGLEMDS "lctl set_param fail_loc=0"
834
835        do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000115"
836        kill -USR1 $close_pid
837        cancel_lru_locks mdc
838        wait $close_pid || return 1
839        wait $open_pid || return 2
840
841        do_facet $SINGLEMDS "lctl set_param fail_loc=0"
842
843        $CHECKSTAT -t file $DIR/$tdir-1/f || return 2
844        $CHECKSTAT -t file $DIR/$tdir-2/f || return 3
845        rm -rf $DIR/$tdir-*
846 }
847 run_test 21c "drop both request while close and open are both in flight"
848
849 test_21d() {
850        mkdir -p $DIR/$tdir-1
851        mkdir -p $DIR/$tdir-2
852        multiop_bg_pause $DIR/$tdir-1/f O_c || return 1
853        pid=$!
854
855        do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000129"
856        $MULTIOP $DIR/$tdir-2/f Oc &
857        sleep 1
858        do_facet $SINGLEMDS "lctl set_param fail_loc=0"
859
860        do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000122"
861        kill -USR1 $pid
862        cancel_lru_locks mdc
863        wait $pid || return 1
864        do_facet $SINGLEMDS "lctl set_param fail_loc=0"
865
866        $CHECKSTAT -t file $DIR/$tdir-1/f || return 2
867        $CHECKSTAT -t file $DIR/$tdir-2/f || return 3
868
869        rm -rf $DIR/$tdir-*
870 }
871 run_test 21d "drop close reply while close and open are both in flight"
872
873 test_21e() {
874        mkdir -p $DIR/$tdir-1
875        mkdir -p $DIR/$tdir-2
876        multiop_bg_pause $DIR/$tdir-1/f O_c || return 1
877        pid=$!
878
879        do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000119"
880        touch $DIR/$tdir-2/f &
881        sleep 1
882        do_facet $SINGLEMDS "lctl set_param fail_loc=0"
883
884        kill -USR1 $pid
885        cancel_lru_locks mdc
886        wait $pid || return 1
887
888        sleep $TIMEOUT
889        $CHECKSTAT -t file $DIR/$tdir-1/f || return 2
890        $CHECKSTAT -t file $DIR/$tdir-2/f || return 3
891        rm -rf $DIR/$tdir-*
892 }
893 run_test 21e "drop open reply while close and open are both in flight"
894
895 test_21f() {
896        mkdir -p $DIR/$tdir-1
897        mkdir -p $DIR/$tdir-2
898        multiop_bg_pause $DIR/$tdir-1/f O_c || return 1
899        pid=$!
900
901        do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000119"
902        touch $DIR/$tdir-2/f &
903        sleep 1
904        do_facet $SINGLEMDS "lctl set_param fail_loc=0"
905
906        do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000122"
907        kill -USR1 $pid
908        cancel_lru_locks mdc
909        wait $pid || return 1
910        do_facet $SINGLEMDS "lctl set_param fail_loc=0"
911
912        $CHECKSTAT -t file $DIR/$tdir-1/f || return 2
913        $CHECKSTAT -t file $DIR/$tdir-2/f || return 3
914        rm -rf $DIR/$tdir-*
915 }
916 run_test 21f "drop both reply while close and open are both in flight"
917
918 test_21g() {
919        mkdir -p $DIR/$tdir-1
920        mkdir -p $DIR/$tdir-2
921        multiop_bg_pause $DIR/$tdir-1/f O_c || return 1
922        pid=$!
923
924        do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000119"
925        touch $DIR/$tdir-2/f &
926        sleep 1
927        do_facet $SINGLEMDS "lctl set_param fail_loc=0"
928
929        do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000115"
930        kill -USR1 $pid
931        cancel_lru_locks mdc
932        wait $pid || return 1
933        do_facet $SINGLEMDS "lctl set_param fail_loc=0"
934
935        $CHECKSTAT -t file $DIR/$tdir-1/f || return 2
936        $CHECKSTAT -t file $DIR/$tdir-2/f || return 3
937        rm -rf $DIR/$tdir-*
938 }
939 run_test 21g "drop open reply and close request while close and open are both in flight"
940
941 test_21h() {
942        mkdir -p $DIR/$tdir-1
943        mkdir -p $DIR/$tdir-2
944        multiop_bg_pause $DIR/$tdir-1/f O_c || return 1
945        pid=$!
946
947        do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000107"
948        touch $DIR/$tdir-2/f &
949        touch_pid=$!
950        sleep 1
951        do_facet $SINGLEMDS "lctl set_param fail_loc=0"
952
953        do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000122"
954        cancel_lru_locks mdc
955        kill -USR1 $pid
956        wait $pid || return 1
957        do_facet $SINGLEMDS "lctl set_param fail_loc=0"
958
959        wait $touch_pid || return 2
960
961        $CHECKSTAT -t file $DIR/$tdir-1/f || return 3
962        $CHECKSTAT -t file $DIR/$tdir-2/f || return 4
963        rm -rf $DIR/$tdir-*
964 }
965 run_test 21h "drop open request and close reply while close and open are both in flight"
966
967 # bug 3462 - multiple MDC requests
968 test_22() {
969     f1=$DIR/${tfile}-1
970     f2=$DIR/${tfile}-2
971     
972     do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000115"
973     $MULTIOP $f2 Oc &
974     close_pid=$!
975
976     sleep 1
977     $MULTIOP $f1 msu || return 1
978
979     cancel_lru_locks mdc
980     do_facet $SINGLEMDS "lctl set_param fail_loc=0"
981
982     wait $close_pid || return 2
983     rm -rf $f2 || return 4
984 }
985 run_test 22 "drop close request and do mknod"
986
987 test_23() { #b=4561
988     multiop_bg_pause $DIR/$tfile O_c || return 1
989     pid=$!
990     # give a chance for open
991     sleep 5
992
993     # try the close
994     drop_request "kill -USR1 $pid"
995
996     fail $SINGLEMDS
997     wait $pid || return 1
998     return 0
999 }
1000 run_test 23 "client hang when close a file after mds crash"
1001
1002 test_24a() { # bug 11710 details correct fsync() behavior
1003         remote_ost_nodsh && skip "remote OST with nodsh" && return 0
1004
1005         mkdir -p $DIR/$tdir
1006         $LFS setstripe -i 0 -c 1 $DIR/$tdir
1007         cancel_lru_locks osc
1008         multiop_bg_pause $DIR/$tdir/$tfile Owy_wyc || return 1
1009         MULTI_PID=$!
1010         ost_evict_client
1011         kill -USR1 $MULTI_PID
1012         wait $MULTI_PID
1013         rc=$?
1014         lctl set_param fail_loc=0x0
1015         client_reconnect
1016         [ $rc -eq 0 ] &&
1017                 error_ignore bz5494 "multiop didn't fail fsync: rc $rc" || true
1018 }
1019 run_test 24a "fsync error (should return error)"
1020
1021 wait_client_evicted () {
1022         local facet=$1
1023         local exports=$2
1024         local varsvc=${facet}_svc
1025
1026         wait_update $(facet_active_host $facet) \
1027                 "lctl get_param -n *.${!varsvc}.num_exports | cut -d' ' -f2" \
1028                 $((exports - 1)) $3
1029 }
1030
1031 test_24b() {
1032         remote_ost_nodsh && skip "remote OST with nodsh" && return 0
1033
1034         dmesg -c > /dev/null
1035         mkdir -p $DIR/$tdir
1036         lfs setstripe $DIR/$tdir -S 0 -i 0 -c 1 ||
1037                 error "$LFS setstripe failed"
1038         cancel_lru_locks osc
1039         multiop_bg_pause $DIR/$tdir/$tfile-1 Ow8192_yc ||
1040                 error "mulitop Ow8192_yc failed"
1041
1042         MULTI_PID1=$!
1043         multiop_bg_pause $DIR/$tdir/$tfile-2 Ow8192_c ||
1044                 error "mulitop Ow8192_c failed"
1045
1046         MULTI_PID2=$!
1047         ost_evict_client
1048
1049         kill -USR1 $MULTI_PID1
1050         wait $MULTI_PID1
1051         rc1=$?
1052         kill -USR1 $MULTI_PID2
1053         wait $MULTI_PID2
1054         rc2=$?
1055         lctl set_param fail_loc=0x0
1056         client_reconnect
1057         [ $rc1 -eq 0 -o $rc2 -eq 0 ] &&
1058         error_ignore bz5494 "multiop didn't fail fsync: $rc1 or close: $rc2" ||
1059                 true
1060
1061         dmesg | grep "dirty page discard:" ||
1062                 error "no discarded dirty page found!"
1063 }
1064 run_test 24b "test dirty page discard due to client eviction"
1065
1066 test_26a() {      # was test_26 bug 5921 - evict dead exports by pinger
1067 # this test can only run from a client on a separate node.
1068         remote_ost || { skip "local OST" && return 0; }
1069         remote_ost_nodsh && skip "remote OST with nodsh" && return 0
1070         remote_mds || { skip "local MDS" && return 0; }
1071
1072         if [ $(facet_host mgs) = $(facet_host ost1) ]; then
1073                 skip "msg and ost1 are at the same node"
1074                 return 0
1075         fi
1076
1077         check_timeout || return 1
1078
1079         local OST_NEXP=$(do_facet ost1 lctl get_param -n obdfilter.${ost1_svc}.num_exports | cut -d' ' -f2)
1080
1081         echo starting with $OST_NEXP OST exports
1082 # OBD_FAIL_PTLRPC_DROP_RPC 0x505
1083         do_facet client lctl set_param fail_loc=0x505
1084         # evictor takes PING_EVICT_TIMEOUT + 3 * PING_INTERVAL to evict.
1085         # But if there's a race to start the evictor from various obds,
1086         # the loser might have to wait for the next ping.
1087
1088         local rc=0
1089         wait_client_evicted ost1 $OST_NEXP $((TIMEOUT * 2 + TIMEOUT * 3 / 4))
1090         rc=$?
1091         do_facet client lctl set_param fail_loc=0x0
1092         [ $rc -eq 0 ] || error "client not evicted from OST"
1093 }
1094 run_test 26a "evict dead exports"
1095
1096 test_26b() {      # bug 10140 - evict dead exports by pinger
1097         remote_ost_nodsh && skip "remote OST with nodsh" && return 0
1098
1099         if [ $(facet_host mgs) = $(facet_host ost1) ]; then
1100                 skip "msg and ost1 are at the same node"
1101                 return 0
1102         fi
1103
1104         check_timeout || return 1
1105         clients_up
1106         zconf_mount `hostname` $MOUNT2 ||
1107                 { error "Failed to mount $MOUNT2"; return 2; }
1108         sleep 1 # wait connections being established
1109
1110         local MDS_NEXP=$(do_facet $SINGLEMDS lctl get_param -n mdt.${mds1_svc}.num_exports | cut -d' ' -f2)
1111         local OST_NEXP=$(do_facet ost1 lctl get_param -n obdfilter.${ost1_svc}.num_exports | cut -d' ' -f2)
1112
1113         echo starting with $OST_NEXP OST and $MDS_NEXP MDS exports
1114
1115         zconf_umount `hostname` $MOUNT2 -f
1116
1117         # PING_INTERVAL max(obd_timeout / 4, 1U)
1118         # PING_EVICT_TIMEOUT (PING_INTERVAL * 6)
1119
1120         # evictor takes PING_EVICT_TIMEOUT + 3 * PING_INTERVAL to evict.  
1121         # But if there's a race to start the evictor from various obds, 
1122         # the loser might have to wait for the next ping.
1123         # = 9 * PING_INTERVAL + PING_INTERVAL
1124         # = 10 PING_INTERVAL = 10 obd_timeout / 4 = 2.5 obd_timeout
1125         # let's wait $((TIMEOUT * 3)) # bug 19887
1126         local rc=0
1127         wait_client_evicted ost1 $OST_NEXP $((TIMEOUT * 3)) || \
1128                 error "Client was not evicted by ost" rc=1
1129         wait_client_evicted $SINGLEMDS $MDS_NEXP $((TIMEOUT * 3)) || \
1130                 error "Client was not evicted by mds"
1131 }
1132 run_test 26b "evict dead exports"
1133
1134 test_27() {
1135         mkdir -p $DIR/$tdir
1136         writemany -q -a $DIR/$tdir/$tfile 0 5 &
1137         CLIENT_PID=$!
1138         sleep 1
1139         local save_FAILURE_MODE=$FAILURE_MODE
1140         FAILURE_MODE="SOFT"
1141         facet_failover $SINGLEMDS
1142 #define OBD_FAIL_OSC_SHUTDOWN            0x407
1143         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000407
1144         # need to wait for reconnect
1145         echo waiting for fail_loc
1146         wait_update_facet $SINGLEMDS "lctl get_param -n fail_loc" "-2147482617"
1147         facet_failover $SINGLEMDS
1148         #no crashes allowed!
1149         kill -USR1 $CLIENT_PID
1150         wait $CLIENT_PID 
1151         true
1152         FAILURE_MODE=$save_FAILURE_MODE
1153 }
1154 run_test 27 "fail LOV while using OSC's"
1155
1156 test_28() {      # bug 6086 - error adding new clients
1157         do_facet client mcreate $DIR/$tfile       || return 1
1158         drop_bl_callback_once "chmod 0777 $DIR/$tfile" ||
1159                 echo "evicted as expected"
1160         #define OBD_FAIL_MDS_CLIENT_ADD 0x12f
1161         do_facet $SINGLEMDS "lctl set_param fail_loc=0x8000012f"
1162         # fail once (evicted), reconnect fail (fail_loc), ok
1163         client_up || (sleep 10; client_up) || (sleep 10; client_up) || error "reconnect failed"
1164         rm -f $DIR/$tfile
1165         fail $SINGLEMDS         # verify MDS last_rcvd can be loaded
1166 }
1167 run_test 28 "handle error adding new clients (bug 6086)"
1168
1169 test_29a() { # bug 22273 - error adding new clients
1170         #define OBD_FAIL_TGT_CLIENT_ADD 0x711
1171         do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000711"
1172         # fail abort so client will be new again
1173         fail_abort $SINGLEMDS
1174         client_up || error "reconnect failed"
1175         wait_osc_import_state $SINGLEMDS ost FULL
1176         return 0
1177 }
1178 run_test 29a "error adding new clients doesn't cause LBUG (bug 22273)"
1179
1180 test_29b() { # bug 22273 - error adding new clients
1181         #define OBD_FAIL_TGT_CLIENT_ADD 0x711
1182         do_facet ost1 "lctl set_param fail_loc=0x80000711"
1183         # fail abort so client will be new again
1184         fail_abort ost1
1185         client_up || error "reconnect failed"
1186         return 0
1187 }
1188 run_test 29b "error adding new clients doesn't cause LBUG (bug 22273)"
1189
1190 test_50() {
1191         mkdir -p $DIR/$tdir
1192         # put a load of file creates/writes/deletes
1193         writemany -q $DIR/$tdir/$tfile 0 5 &
1194         CLIENT_PID=$!
1195         echo writemany pid $CLIENT_PID
1196         sleep 10
1197         FAILURE_MODE="SOFT"
1198         fail $SINGLEMDS
1199         # wait for client to reconnect to MDS
1200         sleep 60
1201         fail $SINGLEMDS
1202         sleep 60
1203         fail $SINGLEMDS
1204         # client process should see no problems even though MDS went down
1205         sleep $TIMEOUT
1206         kill -USR1 $CLIENT_PID
1207         wait $CLIENT_PID 
1208         rc=$?
1209         echo writemany returned $rc
1210         #these may fail because of eviction due to slow AST response.
1211         [ $rc -eq 0 ] ||
1212                 error_ignore bz13652 "writemany returned rc $rc" || true
1213 }
1214 run_test 50 "failover MDS under load"
1215
1216 test_51() {
1217         #define OBD_FAIL_MDS_SYNC_CAPA_SL                    0x1310
1218         do_facet ost1 lctl set_param fail_loc=0x00001310
1219
1220         mkdir -p $DIR/$tdir
1221         # put a load of file creates/writes/deletes
1222         writemany -q $DIR/$tdir/$tfile 0 5 &
1223         CLIENT_PID=$!
1224         sleep 1
1225         FAILURE_MODE="SOFT"
1226         facet_failover $SINGLEMDS
1227         # failover at various points during recovery
1228         SEQ="1 5 10 $(seq $TIMEOUT 5 $(($TIMEOUT+10)))"
1229         echo will failover at $SEQ
1230         for i in $SEQ
1231         do
1232                 #echo failover in $i sec
1233                 log "test_$testnum: failover in $i sec"
1234                 sleep $i
1235                 facet_failover $SINGLEMDS
1236         done
1237         # client process should see no problems even though MDS went down
1238         # and recovery was interrupted
1239         sleep $TIMEOUT
1240         kill -USR1 $CLIENT_PID
1241         wait $CLIENT_PID
1242         rc=$?
1243         echo writemany returned $rc
1244         [ $rc -eq 0 ] ||
1245                 error_ignore bz13652 "writemany returned rc $rc" || true
1246 }
1247 run_test 51 "failover MDS during recovery"
1248
1249 test_52_guts() {
1250         do_facet client "mkdir -p $DIR/$tdir"
1251         do_facet client "writemany -q -a $DIR/$tdir/$tfile 300 5" &
1252         CLIENT_PID=$!
1253         echo writemany pid $CLIENT_PID
1254         sleep 10
1255         FAILURE_MODE="SOFT"
1256         fail ost1
1257         rc=0
1258         wait $CLIENT_PID || rc=$?
1259         # active client process should see an EIO for down OST
1260         [ $rc -eq 5 ] && { echo "writemany correctly failed $rc" && return 0; }
1261         # but timing or failover setup may allow success
1262         [ $rc -eq 0 ] && { echo "writemany succeeded" && return 0; }
1263         echo "writemany returned $rc"
1264         return $rc
1265 }
1266
1267 test_52() {
1268         remote_ost_nodsh && skip "remote OST with nodsh" && return 0
1269
1270         mkdir -p $DIR/$tdir
1271         test_52_guts
1272         rc=$?
1273         [ $rc -ne 0 ] && { return $rc; }
1274         # wait for client to reconnect to OST
1275         sleep 30
1276         test_52_guts
1277         rc=$?
1278         [ $rc -ne 0 ] && { return $rc; }
1279         sleep 30
1280         test_52_guts
1281         rc=$?
1282         client_reconnect
1283         #return $rc
1284 }
1285 run_test 52 "failover OST under load"
1286
1287 # test of open reconstruct
1288 test_53() {
1289         touch $DIR/$tfile
1290         drop_ldlm_reply "openfile -f O_RDWR:O_CREAT -m 0755 $DIR/$tfile" ||\
1291                 return 2
1292 }
1293 run_test 53 "touch: drop rep"
1294
1295 test_54() {
1296         zconf_mount `hostname` $MOUNT2
1297         touch $DIR/$tfile
1298         touch $DIR2/$tfile.1
1299         sleep 10
1300         cat $DIR2/$tfile.missing # save transno = 0, rc != 0 into last_rcvd
1301         fail $SINGLEMDS
1302         umount $MOUNT2
1303         ERROR=`dmesg | egrep "(test 54|went back in time)" | tail -n1 | grep "went back in time"`
1304         [ x"$ERROR" == x ] || error "back in time occured"
1305 }
1306 run_test 54 "back in time"
1307
1308 # bug 11330 - liblustre application death during I/O locks up OST
1309 test_55() {
1310         remote_ost_nodsh && skip "remote OST with nodsh" && return 0
1311
1312         mkdir -p $DIR/$tdir
1313
1314         # Minimum pass speed is 2MBps
1315         local ddtimeout=64
1316         # LU-2887/LU-3089 - set min pass speed to 500KBps
1317         [ "$(facet_fstype ost1)" = "zfs" ] && ddtimeout=256
1318
1319         # first dd should be finished quickly
1320         $LFS setstripe -c 1 -i 0 $DIR/$tdir/$tfile-1
1321         dd if=/dev/zero of=$DIR/$tdir/$tfile-1 bs=32M count=4 &
1322         DDPID=$!
1323         count=0
1324         echo  "step1: testing ......"
1325         while kill -0 $DDPID 2> /dev/null; do
1326                 let count++
1327                 if [ $count -gt $ddtimeout ]; then
1328                         error "dd should be finished!"
1329                 fi
1330                 sleep 1
1331         done
1332         echo "(dd_pid=$DDPID, time=$count)successful"
1333
1334         $LFS setstripe -c 1 -i 0 $DIR/$tdir/$tfile-2
1335         #define OBD_FAIL_OST_DROP_REQ            0x21d
1336         do_facet ost1 lctl set_param fail_loc=0x0000021d
1337         # second dd will be never finished
1338         dd if=/dev/zero of=$DIR/$tdir/$tfile-2 bs=32M count=4 &
1339         DDPID=$!
1340         count=0
1341         echo  "step2: testing ......"
1342         while [ $count -le $ddtimeout ]; do
1343                 if ! kill -0 $DDPID 2> /dev/null; then
1344                         ls -l $DIR/$tdir
1345                         error "dd shouldn't be finished! (time=$count)"
1346                 fi
1347                 let count++
1348                 sleep 1
1349         done
1350         echo "(dd_pid=$DDPID, time=$count)successful"
1351
1352         #Recover fail_loc and dd will finish soon
1353         do_facet ost1 lctl set_param fail_loc=0
1354         count=0
1355         echo  "step3: testing ......"
1356         while kill -0 $DDPID 2> /dev/null; do
1357                 let count++
1358                 if [ $count -gt $((ddtimeout + 440)) ]; then
1359                         error "dd should be finished!"
1360                 fi
1361                 sleep 1
1362         done
1363         echo "(dd_pid=$DDPID, time=$count)successful"
1364
1365         rm -rf $DIR/$tdir
1366 }
1367 run_test 55 "ost_brw_read/write drops timed-out read/write request"
1368
1369 test_56() { # b=11277
1370 #define OBD_FAIL_MDS_RESEND      0x136
1371         touch $DIR/$tfile
1372         do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000136"
1373         stat $DIR/$tfile || error "stat failed"
1374         do_facet $SINGLEMDS "lctl set_param fail_loc=0"
1375         rm -f $DIR/$tfile
1376 }
1377 run_test 56 "do not fail on getattr resend"
1378
1379 test_57_helper() {
1380         # no oscs means no client or mdt 
1381         while lctl get_param osc.*.* > /dev/null 2>&1; do
1382                 : # loop until proc file is removed
1383         done
1384 }
1385
1386 test_57() { # bug 10866
1387         test_57_helper &
1388         pid=$!
1389         sleep 1
1390 #define OBD_FAIL_LPROC_REMOVE            0xB00
1391         lctl set_param fail_loc=0x80000B00
1392         zconf_umount `hostname` $DIR
1393         lctl set_param fail_loc=0x80000B00
1394         fail_abort $SINGLEMDS
1395         kill -9 $pid
1396         lctl set_param fail_loc=0
1397         mount_client $DIR
1398         do_facet client "df $DIR"
1399 }
1400 run_test 57 "read procfs entries causes kernel crash"
1401
1402 test_58() { # bug 11546
1403 #define OBD_FAIL_MDC_ENQUEUE_PAUSE        0x801
1404         touch $DIR/$tfile
1405         ls -la $DIR/$tfile
1406         lctl set_param fail_loc=0x80000801
1407         cp $DIR/$tfile /dev/null &
1408         pid=$!
1409         sleep 1
1410         lctl set_param fail_loc=0
1411         drop_bl_callback_once rm -f $DIR/$tfile
1412         wait $pid
1413         # the first 'df' could tigger the eviction caused by
1414         # 'drop_bl_callback_once', and it's normal case.
1415         # but the next 'df' should return successfully.
1416         do_facet client "df $DIR" || do_facet client "df $DIR"
1417 }
1418 run_test 58 "Eviction in the middle of open RPC reply processing"
1419
1420 test_59() { # bug 10589
1421         zconf_mount `hostname` $MOUNT2 || error "Failed to mount $MOUNT2"
1422         echo $DIR2 | grep -q $MOUNT2 || error "DIR2 is not set properly: $DIR2"
1423 #define OBD_FAIL_LDLM_CANCEL_EVICT_RACE  0x311
1424         lctl set_param fail_loc=0x311
1425         writes=$(LANG=C dd if=/dev/zero of=$DIR2/$tfile count=1 2>&1)
1426         [ $? = 0 ] || error "dd write failed"
1427         writes=$(echo $writes | awk  -F '+' '/out/ {print $1}')
1428         lctl set_param fail_loc=0
1429         sync
1430         zconf_umount `hostname` $MOUNT2 -f
1431         reads=$(LANG=C dd if=$DIR/$tfile of=/dev/null 2>&1)
1432         [ $? = 0 ] || error "dd read failed"
1433         reads=$(echo $reads | awk -F '+' '/in/ {print $1}')
1434         [ "$reads" -eq "$writes" ] || error "read" $reads "blocks, must be" $writes
1435 }
1436 run_test 59 "Read cancel race on client eviction"
1437
1438 err17935 () {
1439         # we assume that all md changes are in the MDT0 changelog
1440         if [ $MDSCOUNT -gt 1 ]; then
1441                 error_ignore bz17935 $*
1442         else
1443                 error $*
1444         fi
1445 }
1446
1447 test_60() {
1448         MDT0=$($LCTL get_param -n mdc.*.mds_server_uuid |
1449                 awk '{ gsub(/_UUID/,""); print $1 }' | head -n1)
1450
1451         NUM_FILES=15000
1452         mkdir -p $DIR/$tdir
1453
1454         # Register (and start) changelog
1455         USER=$(do_facet $SINGLEMDS lctl --device $MDT0 changelog_register -n)
1456         echo "Registered as $MDT0 changelog user $USER"
1457
1458         # Generate a large number of changelog entries
1459         createmany -o $DIR/$tdir/$tfile $NUM_FILES
1460         sync
1461         sleep 5
1462
1463         # Unlink files in the background
1464         unlinkmany $DIR/$tdir/$tfile $NUM_FILES &
1465         CLIENT_PID=$!
1466         sleep 1
1467
1468         # Failover the MDS while unlinks are happening
1469         facet_failover $SINGLEMDS
1470
1471         # Wait for unlinkmany to finish
1472         wait $CLIENT_PID
1473
1474         # Check if all the create/unlink events were recorded
1475         # in the changelog
1476         $LFS changelog $MDT0 >> $DIR/$tdir/changelog
1477         local cl_count=$(grep UNLNK $DIR/$tdir/changelog | wc -l)
1478         echo "$cl_count unlinks in $MDT0 changelog"
1479
1480         do_facet $SINGLEMDS lctl --device $MDT0 changelog_deregister $USER
1481         USERS=$(( $(do_facet $SINGLEMDS lctl get_param -n \
1482             mdd.$MDT0.changelog_users | wc -l) - 2 ))
1483         if [ $USERS -eq 0 ]; then
1484             [ $cl_count -eq $NUM_FILES ] || \
1485                 err17935 "Recorded ${cl_count} unlinks out of $NUM_FILES"
1486             # Also make sure we can clear large changelogs
1487             cl_count=$($LFS changelog $FSNAME | wc -l)
1488             [ $cl_count -le 2 ] || \
1489                 error "Changelog not empty: $cl_count entries"
1490         else
1491             # If there are other users, there may be other unlinks in the log
1492             [ $cl_count -ge $NUM_FILES ] || \
1493                 err17935 "Recorded ${cl_count} unlinks out of $NUM_FILES"
1494             echo "$USERS other changelog users; can't verify clear"
1495         fi
1496 }
1497 run_test 60 "Add Changelog entries during MDS failover"
1498
1499 test_61()
1500 {
1501         local mdtosc=$(get_mdtosc_proc_path $SINGLEMDS $FSNAME-OST0000)
1502         mdtosc=${mdtosc/-MDT*/-MDT\*}
1503         local cflags="osc.$mdtosc.connect_flags"
1504         do_facet $SINGLEMDS "lctl get_param -n $cflags" |grep -q skip_orphan
1505         [ $? -ne 0 ] && skip "don't have skip orphan feature" && return
1506
1507         mkdir -p $DIR/$tdir || error "mkdir dir $DIR/$tdir failed"
1508         # Set the default stripe of $DIR/$tdir to put the files to ost1
1509         $LFS setstripe -c 1 -i 0 $DIR/$tdir
1510
1511         replay_barrier $SINGLEMDS
1512         createmany -o $DIR/$tdir/$tfile-%d 10 
1513         local oid=$(do_facet ost1 "lctl get_param -n \
1514                 obdfilter.${ost1_svc}.last_id" | sed -e 's/.*://')
1515
1516         fail_abort $SINGLEMDS
1517
1518         touch $DIR/$tdir/$tfile
1519         local id=$($LFS getstripe $DIR/$tdir/$tfile |
1520                 awk '$1 == 0 { print $2 }')
1521         [ $id -le $oid ] && error "the orphan objid was reused, failed"
1522
1523         # Cleanup
1524         rm -rf $DIR/$tdir
1525 }
1526 run_test 61 "Verify to not reuse orphan objects - bug 17025"
1527
1528 # test_62 as seen it b2_1 please do not reuse test_62
1529 #test_62()
1530 #{
1531 #       zconf_umount `hostname` $DIR
1532 #       #define OBD_FAIL_PTLRPC_DELAY_IMP_FULL   0x516
1533 #       lctl set_param fail_loc=0x516
1534 #       mount_client $DIR
1535 #}
1536 #run_test 62 "Verify connection flags race - bug LU-1716"
1537
1538 test_66()
1539 {
1540         [[ $(lustre_version_code $SINGLEMDS) -ge $(version_code 2.7.51) ]] ||
1541                 { skip "Need MDS version at least 2.7.51"; return 0; }
1542
1543         local list=$(comma_list $(osts_nodes))
1544
1545         # modify dir so that next revalidate would not obtain UPDATE lock
1546         touch $DIR
1547
1548         # drop 1 reply with UPDATE lock
1549         mcreate $DIR/$tfile || error "mcreate failed: $?"
1550         drop_ldlm_reply_once "stat $DIR/$tfile" &
1551         sleep 2
1552
1553         # make the re-sent lock to sleep
1554 #define OBD_FAIL_MDS_RESEND              0x136
1555         do_nodes $list $LCTL set_param fail_loc=0x80000136
1556
1557         #initiate the re-connect & re-send
1558         local mdccli=$($LCTL dl | awk '/-mdc-/ {print $4;}')
1559         local conn_uuid=$($LCTL get_param -n mdc.${mdccli}.mds_conn_uuid)
1560         $LCTL set_param "mdc.${mdccli}.import=connection=${conn_uuid}"
1561         sleep 2
1562
1563         #initiate the client eviction while enqueue re-send is in progress
1564         mds_evict_client
1565
1566         client_reconnect
1567         wait
1568 }
1569 run_test 66 "lock enqueue re-send vs client eviction"
1570
1571 test_65() {
1572         mount_client $DIR2
1573
1574         #grant lock1, export2
1575         $SETSTRIPE -i -0 $DIR2/$tfile || return 1
1576         $MULTIOP $DIR2/$tfile Ow  || return 2
1577
1578 #define OBD_FAIL_LDLM_BL_EVICT            0x31e
1579         do_facet ost $LCTL set_param fail_loc=0x31e
1580         #get waiting lock2, export1
1581         $MULTIOP $DIR/$tfile Ow &
1582         PID1=$!
1583         # let enqueue to get asleep
1584         sleep 2
1585
1586         #get lock2 blocked
1587         $MULTIOP $DIR2/$tfile Ow &
1588         PID2=$!
1589         sleep 2
1590
1591         #evict export1
1592         ost_evict_client
1593
1594         sleep 2
1595         do_facet ost $LCTL set_param fail_loc=0
1596
1597         wait $PID1
1598         wait $PID2
1599
1600         umount_client $DIR2
1601 }
1602 run_test 65 "lock enqueue for destroyed export"
1603
1604 check_cli_ir_state()
1605 {
1606         local NODE=${1:-$HOSTNAME}
1607         local st
1608         st=$(do_node $NODE "lctl get_param mgc.*.ir_state |
1609                             awk '/imperative_recovery:/ { print \\\$2}'")
1610         [ $st != ON -o $st != OFF -o $st != ENABLED -o $st != DISABLED ] ||
1611                 error "Error state $st, must be ENABLED or DISABLED"
1612         echo -n $st
1613 }
1614
1615 check_target_ir_state()
1616 {
1617         local target=${1}
1618         local name=${target}_svc
1619         local recovery_proc=obdfilter.${!name}.recovery_status
1620         local st
1621
1622         while : ; do
1623                 st=$(do_facet $target "$LCTL get_param -n $recovery_proc |
1624                         awk '/status:/{ print \\\$2}'")
1625                 [ x$st = xRECOVERING ] || break
1626         done
1627         st=$(do_facet $target "lctl get_param -n $recovery_proc |
1628                                awk '/IR:/{ print \\\$2}'")
1629         [ $st != ON -o $st != OFF -o $st != ENABLED -o $st != DISABLED ] ||
1630                 error "Error state $st, must be ENABLED or DISABLED"
1631         echo -n $st
1632 }
1633
1634 set_ir_status()
1635 {
1636         do_facet mgs lctl set_param -n mgs.MGS.live.$FSNAME="state=$1"
1637 }
1638
1639 get_ir_status()
1640 {
1641         local state=$(do_facet mgs "lctl get_param -n mgs.MGS.live.$FSNAME |
1642                                     awk '/state:/{ print \\\$2 }'")
1643         echo -n ${state/,/}
1644 }
1645
1646 nidtbl_version_mgs()
1647 {
1648         local ver=$(do_facet mgs "lctl get_param -n mgs.MGS.live.$FSNAME |
1649                                   awk '/nidtbl_version:/{ print \\\$2 }'")
1650         echo -n $ver
1651 }
1652
1653 # nidtbl_version_client <mds1|client> [node]
1654 nidtbl_version_client()
1655 {
1656         local cli=$1
1657         local node=${2:-$HOSTNAME}
1658
1659         if [ X$cli = Xclient ]; then
1660                 cli=$FSNAME-client
1661         else
1662                 local obdtype=${cli/%[0-9]*/}
1663                 [ $obdtype != mds ] && error "wrong parameters $cli"
1664
1665                 node=$(facet_active_host $cli)
1666                 local t=${cli}_svc
1667                 cli=${!t}
1668         fi
1669
1670         local vers=$(do_node $node "lctl get_param -n mgc.*.ir_state" |
1671                      awk "/$cli/{print \$6}" |sort -u)
1672
1673         # in case there are multiple mounts on the client node
1674         local arr=($vers)
1675         [ ${#arr[@]} -ne 1 ] && error "versions on client node mismatch"
1676         echo -n $vers
1677 }
1678
1679 nidtbl_versions_match()
1680 {
1681         [ $(nidtbl_version_mgs) -eq $(nidtbl_version_client ${1:-client}) ]
1682 }
1683
1684 target_instance_match()
1685 {
1686         local srv=$1
1687         local obdtype
1688         local cliname
1689
1690         obdtype=${srv/%[0-9]*/}
1691         case $obdtype in
1692         mds)
1693                 obdname="mdt"
1694                 cliname="mdc"
1695                 ;;
1696         ost)
1697                 obdname="obdfilter"
1698                 cliname="osc"
1699                 ;;
1700         *)
1701                 error "invalid target type" $srv
1702                 return 1
1703                 ;;
1704         esac
1705
1706         local target=${srv}_svc
1707         local si=$(do_facet $srv lctl get_param -n $obdname.${!target}.instance)
1708         local ci=$(lctl get_param -n $cliname.${!target}-${cliname}-*.import |
1709                 awk '/instance/{ print $2 }' | head -n1)
1710
1711         return $([ $si -eq $ci ])
1712 }
1713
1714 test_100()
1715 {
1716         do_facet mgs $LCTL list_param mgs.*.ir_timeout ||
1717                 { skip "MGS without IR support"; return 0; }
1718
1719         # MDT was just restarted in the previous test, make sure everything
1720         # is all set.
1721         local cnt=30
1722         while [ $cnt -gt 0 ]; do
1723                 nidtbl_versions_match && break
1724                 sleep 1
1725                 cnt=$((cnt - 1))
1726         done
1727
1728         # disable IR
1729         set_ir_status disabled
1730
1731         local prev_ver=$(nidtbl_version_client client)
1732
1733         local saved_FAILURE_MODE=$FAILURE_MODE
1734         [ $(facet_host mgs) = $(facet_host ost1) ] && FAILURE_MODE="SOFT"
1735         fail ost1
1736
1737         # valid check
1738         [ $(nidtbl_version_client client) -eq $prev_ver ] ||
1739                 error "version must not change due to IR disabled"
1740         target_instance_match ost1 || error "instance mismatch"
1741
1742         # restore env
1743         set_ir_status full
1744         FAILURE_MODE=$saved_FAILURE_MODE
1745 }
1746 run_test 100 "IR: Make sure normal recovery still works w/o IR"
1747
1748 test_101()
1749 {
1750         do_facet mgs $LCTL list_param mgs.*.ir_timeout ||
1751                 { skip "MGS without IR support"; return 0; }
1752
1753         set_ir_status full
1754
1755         local OST1_IMP=$(get_osc_import_name client ost1)
1756
1757         # disable pinger recovery
1758         lctl set_param -n osc.$OST1_IMP.pinger_recov=0
1759
1760         fail ost1
1761
1762         target_instance_match ost1 || error "instance mismatch"
1763         nidtbl_versions_match || error "version must match"
1764
1765         lctl set_param -n osc.$OST1_IMP.pinger_recov=1
1766 }
1767 run_test 101 "IR: Make sure IR works w/o normal recovery"
1768
1769 test_102()
1770 {
1771         do_facet mgs $LCTL list_param mgs.*.ir_timeout ||
1772                 { skip "MGS without IR support"; return 0; }
1773
1774         local clients=${CLIENTS:-$HOSTNAME}
1775         local old_version
1776         local new_version
1777         local mgsdev=mgs
1778
1779         set_ir_status full
1780
1781         # let's have a new nidtbl version
1782         fail ost1
1783
1784         # sleep for a while so that clients can see the failure of ost
1785         # it must be MGC_TIMEOUT_MIN_SECONDS + MGC_TIMEOUT_RAND_CENTISEC.
1786         # int mgc_request.c:
1787         # define MGC_TIMEOUT_MIN_SECONDS   5
1788         # define MGC_TIMEOUT_RAND_CENTISEC 0x1ff /* ~500 *
1789         local count=30  # 20 seconds at most
1790         while [ $count -gt 0 ]; do
1791                 nidtbl_versions_match && break
1792                 sleep 1
1793                 count=$((count-1))
1794         done
1795
1796         nidtbl_versions_match || error "nidtbl mismatch"
1797
1798         # get the version #
1799         old_version=$(nidtbl_version_client client)
1800
1801         zconf_umount_clients $clients $MOUNT || error "Cannot umount client"
1802
1803         # restart mgs
1804         combined_mgs_mds && mgsdev=mds1
1805         remount_facet $mgsdev
1806         fail ost1
1807
1808         zconf_mount_clients $clients $MOUNT || error "Cannot mount client"
1809
1810         # check new version
1811         new_version=$(nidtbl_version_client client)
1812         [ $new_version -lt $old_version ] &&
1813                 error "nidtbl version wrong after mgs restarts"
1814         return 0
1815 }
1816 run_test 102 "IR: New client gets updated nidtbl after MGS restart"
1817
1818 test_103()
1819 {
1820         do_facet mgs $LCTL list_param mgs.*.ir_timeout ||
1821                 { skip "MGS without IR support"; return 0; }
1822
1823         combined_mgs_mds && skip "mgs and mds on the same target" && return 0
1824
1825         # workaround solution to generate config log on the mds
1826         remount_facet mds1
1827
1828         stop mgs
1829         stop mds1
1830
1831         # We need this test because mds is like a client in IR context.
1832         start mds1 $(mdsdevname 1) $MDS_MOUNT_OPTS ||
1833                 error "MDS should start w/o mgs"
1834
1835         # start mgs and remount mds w/ ir
1836         start mgs $(mgsdevname) $MGS_MOUNT_OPTS
1837         clients_up
1838
1839         # remount client so that fsdb will be created on the MGS
1840         umount_client $MOUNT || error "umount failed"
1841         mount_client $MOUNT || error "mount failed"
1842
1843         # sleep 30 seconds so the MDS has a chance to detect MGS restarting
1844         local count=30
1845         while [ $count -gt 0 ]; do
1846                 [ $(nidtbl_version_client mds1) -ne 0 ] && break
1847                 sleep 1
1848                 count=$((count-1))
1849         done
1850
1851         # after a while, mds should be able to reconnect to mgs and fetch
1852         # up-to-date nidtbl version
1853         nidtbl_versions_match mds1 || error "mds nidtbl mismatch"
1854
1855         # reset everything
1856         set_ir_status full
1857 }
1858 run_test 103 "IR: MDS can start w/o MGS and get updated nidtbl later"
1859
1860 test_104()
1861 {
1862         do_facet mgs $LCTL list_param mgs.*.ir_timeout ||
1863                 { skip "MGS without IR support"; return 0; }
1864
1865         set_ir_status full
1866
1867         stop ost1
1868         start ost1 $(ostdevname 1) "$OST_MOUNT_OPTS -onoir" ||
1869                 error "OST1 cannot start"
1870         clients_up
1871
1872         local ir_state=$(check_target_ir_state ost1)
1873         [ $ir_state = "DISABLED" -o $ir_state = "OFF" ] ||
1874                 error "ir status on ost1 should be DISABLED"
1875 }
1876 run_test 104 "IR: ost can disable IR voluntarily"
1877
1878 test_105()
1879 {
1880         [ -z "$RCLIENTS" ] && skip "Needs multiple clients" && return 0
1881         do_facet mgs $LCTL list_param mgs.*.ir_timeout ||
1882                 { skip "MGS without IR support"; return 0; }
1883
1884         set_ir_status full
1885
1886         # get one of the clients from client list
1887         local rcli=$(echo $RCLIENTS |cut -d' ' -f 1)
1888
1889         local mount_opts=${MOUNT_OPTS:+$MOUNT_OPTS,}noir
1890         zconf_umount $rcli $MOUNT || error "umount failed"
1891         zconf_mount $rcli $MOUNT $mount_opts || error "mount failed"
1892
1893         # make sure lustre mount at $rcli disabling IR
1894         local ir_state=$(check_cli_ir_state $rcli)
1895         [ $ir_state = "DISABLED" -o $ir_state = "OFF" ] ||
1896                 error "IR state must be DISABLED at $rcli"
1897
1898         # Since the client just mounted, its last_rcvd entry is not on disk.
1899         # Send an RPC so exp_need_sync forces last_rcvd to commit this export
1900         # so the client can reconnect during OST recovery (LU-924, LU-1582)
1901         $SETSTRIPE -i 0 $DIR/$tfile
1902         dd if=/dev/zero of=$DIR/$tfile bs=1M count=1 conv=sync
1903
1904         # make sure MGS's state is Partial
1905         [ $(get_ir_status) = "partial" ] || error "MGS IR state must be partial"
1906
1907         fail ost1
1908         # make sure IR on ost1 is DISABLED
1909         local ir_state=$(check_target_ir_state ost1)
1910         [ $ir_state = "DISABLED" -o $ir_state = "OFF" ] ||
1911                 error "IR status on ost1 should be DISABLED"
1912
1913         # remount with the default MOUNT_OPTS
1914         zconf_umount $rcli $MOUNT || error "umount failed"
1915         zconf_mount $rcli $MOUNT || error "mount failed"
1916
1917         # make sure MGS's state is full
1918         [ $(get_ir_status) = "full" ] || error "MGS IR status must be full"
1919
1920         fail ost1
1921         # make sure IR on ost1 is ENABLED
1922         local ir_state=$(check_target_ir_state ost1)
1923         [ $ir_state = "ENABLED" -o $ir_state = "ON" ] ||
1924                 error "IR status on ost1 should be ENABLED"
1925
1926         return 0
1927 }
1928 run_test 105 "IR: NON IR clients support"
1929
1930 cleanup_106() {
1931         trap 0
1932         umount_client $DIR2
1933         debugrestore
1934 }
1935
1936 test_106() { # LU-1789
1937         [[ $(lustre_version_code $SINGLEMDS) -ge $(version_code 2.3.50) ]] ||
1938                 { skip "Need MDS version at least 2.3.50"; return 0; }
1939
1940 #define OBD_FAIL_MDC_LIGHTWEIGHT         0x805
1941         $LCTL set_param fail_loc=0x805
1942
1943         debugsave
1944         trap cleanup_106 EXIT
1945
1946         # enable lightweight flag on mdc connection
1947         mount_client $DIR2
1948
1949         local MDS_NEXP=$(do_facet $SINGLEMDS \
1950                          lctl get_param -n mdt.${mds1_svc}.num_exports |
1951                          cut -d' ' -f2)
1952         $LCTL set_param fail_loc=0
1953
1954         touch $DIR2/$tfile || error "failed to create empty file"
1955         replay_barrier $SINGLEMDS
1956
1957         $LCTL set_param debug=console
1958         $LCTL clear
1959         facet_failover $SINGLEMDS
1960
1961         # lightweight connection must be evicted
1962         touch -c $DIR2/$tfile || true
1963         $LCTL dk $TMP/lustre-log-$TESTNAME.log
1964         evicted=`awk '/This client was evicted by .*MDT0000/ {
1965                                       print;
1966                       }' $TMP/lustre-log-$TESTNAME.log`
1967         [ -z "$evicted" ] && error "lightweight client not evicted by mds"
1968
1969         # and all operations performed by lightweight client should be
1970         # synchronous, so the file created before mds restart should be there
1971         $CHECKSTAT -t file $DIR/$tfile || error "file not present"
1972         rm -f $DIR/$tfile
1973
1974         cleanup_106
1975 }
1976 run_test 106 "lightweight connection support"
1977
1978 test_107 () {
1979         local CLIENT_PID
1980         local close_pid
1981
1982         mkdir -p $DIR/$tdir
1983         # OBD_FAIL_MDS_REINT_NET_REP   0x119
1984         do_facet $SINGLEMDS lctl set_param fail_loc=0x119
1985         multiop $DIR/$tdir D_c &
1986         close_pid=$!
1987         mkdir $DIR/$tdir/dir_106 &
1988         CLIENT_PID=$!
1989         do_facet $SINGLEMDS lctl set_param fail_loc=0
1990         fail $SINGLEMDS
1991
1992         wait $CLIENT_PID || rc=$?
1993         checkstat -t dir $DIR/$tdir/dir_106 || return 1
1994
1995         kill -USR1 $close_pid
1996         wait $close_pid || return 2
1997
1998         return $rc
1999 }
2000 run_test 107 "drop reint reply, then restart MDT"
2001
2002 test_108() {
2003         mkdir -p $DIR/$tdir
2004         $SETSTRIPE -c 1 -i 0 $DIR/$tdir
2005
2006         dd if=/dev/zero of=$DIR/$tdir/$tfile bs=1M count=256 &
2007         local dd_pid=$!
2008         sleep 0.1
2009
2010         ost_evict_client
2011
2012         wait $dd_pid
2013
2014         client_up || error "reconnect failed"
2015         rm -f $DIR/$tdir/$tfile
2016 }
2017 run_test 108 "client eviction don't crash"
2018
2019 test_110a () {
2020         [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
2021         local remote_dir=$DIR/$tdir/remote_dir
2022         local MDTIDX=1
2023         local num
2024
2025         #prepare for 110 test, which need set striped dir on remote MDT.
2026         for num in $(seq $MDSCOUNT); do
2027                 do_facet mds$num \
2028                         lctl set_param -n mdt.${FSNAME}*.enable_remote_dir=1 \
2029                                 2>/dev/null
2030         done
2031
2032         mkdir -p $DIR/$tdir
2033         drop_request "$LFS mkdir -i $MDTIDX -c2 $remote_dir" ||
2034                                         error "lfs mkdir failed"
2035         local diridx=$($GETSTRIPE -M $remote_dir)
2036         [ $diridx -eq $MDTIDX ] || error "$diridx != $MDTIDX"
2037
2038         rm -rf $DIR/$tdir || error "rmdir failed"
2039 }
2040 run_test 110a "create remote directory: drop client req"
2041
2042 test_110b () {
2043         [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
2044         local remote_dir=$DIR/$tdir/remote_dir
2045         local MDTIDX=1
2046
2047         mkdir -p $DIR/$tdir
2048         drop_reint_reply "$LFS mkdir -i $MDTIDX -c2 $remote_dir" ||
2049                                         error "lfs mkdir failed"
2050
2051         diridx=$($GETSTRIPE -M $remote_dir)
2052         [ $diridx -eq $MDTIDX ] || error "$diridx != $MDTIDX"
2053
2054         rm -rf $DIR/$tdir || error "rmdir failed"
2055 }
2056 run_test 110b "create remote directory: drop Master rep"
2057
2058 test_110c () {
2059         [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
2060         local remote_dir=$DIR/$tdir/remote_dir
2061         local MDTIDX=1
2062
2063         mkdir -p $DIR/$tdir
2064         drop_update_reply $MDTIDX "$LFS mkdir -i $MDTIDX -c2 $remote_dir" ||
2065                                                 error "lfs mkdir failed"
2066
2067         diridx=$($GETSTRIPE -M $remote_dir)
2068         [ $diridx -eq $MDTIDX ] || error "$diridx != $MDTIDX"
2069
2070         rm -rf $DIR/$tdir || error "rmdir failed"
2071 }
2072 run_test 110c "create remote directory: drop update rep on slave MDT"
2073
2074 test_110d () {
2075         [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
2076         local remote_dir=$DIR/$tdir/remote_dir
2077         local MDTIDX=1
2078
2079         mkdir -p $DIR/$tdir
2080         $LFS mkdir -i $MDTIDX -c2 $remote_dir || error "lfs mkdir failed"
2081
2082         drop_request "rm -rf $remote_dir" || error "rm remote dir failed"
2083
2084         rm -rf $DIR/$tdir || error "rmdir failed"
2085
2086         return 0
2087 }
2088 run_test 110d "remove remote directory: drop client req"
2089
2090 test_110e () {
2091         [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
2092         local remote_dir=$DIR/$tdir/remote_dir
2093         local MDTIDX=1
2094
2095         mkdir -p $DIR/$tdir
2096         $LFS mkdir -i $MDTIDX -c2 $remote_dir  || error "lfs mkdir failed"
2097         drop_reint_reply "rm -rf $remote_dir" || error "rm remote dir failed"
2098
2099         rm -rf $DIR/$tdir || error "rmdir failed"
2100
2101         return 0
2102 }
2103 run_test 110e "remove remote directory: drop master rep"
2104
2105 test_110f () {
2106         [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
2107         local remote_dir=$DIR/$tdir/remote_dir
2108         local MDTIDX=1
2109
2110         mkdir -p $DIR/$tdir
2111         $LFS mkdir -i $MDTIDX -c2 $remote_dir || error "lfs mkdir failed"
2112         drop_update_reply $MDTIDX "rm -rf $remote_dir" ||
2113                                         error "rm remote dir failed"
2114
2115         rm -rf $DIR/$tdir || error "rmdir failed"
2116 }
2117 run_test 110f "remove remote directory: drop slave rep"
2118
2119 test_110g () {
2120         [[ $(lustre_version_code $SINGLEMDS) -ge $(version_code 2.6.57) ]] ||
2121                 { skip "Need MDS version at least 2.6.57"; return 0; }
2122
2123         [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
2124         local remote_dir=$DIR/$tdir/remote_dir
2125         local MDTIDX=1
2126
2127         mkdir -p $remote_dir
2128
2129         createmany -o $remote_dir/f 100
2130
2131         #define OBD_FAIL_MIGRATE_NET_REP                0x1800
2132         do_facet mds$MDTIDX lctl set_param fail_loc=0x1800
2133         $LFS migrate -m $MDTIDX $remote_dir || error "migrate failed"
2134         do_facet mds$MDTIDX lctl set_param fail_loc=0x0
2135
2136         for file in $(find $remote_dir); do
2137                 mdt_index=$($LFS getstripe -M $file)
2138                 [ $mdt_index == $MDTIDX ] ||
2139                         error "$file is not on MDT${MDTIDX}"
2140         done
2141
2142         rm -rf $DIR/$tdir || error "rmdir failed"
2143 }
2144 run_test 110g "drop reply during migration"
2145
2146 test_110h () {
2147         [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
2148         local src_dir=$DIR/$tdir/source_dir
2149         local tgt_dir=$DIR/$tdir/target_dir
2150         local MDTIDX=1
2151
2152         mkdir -p $src_dir
2153         $LFS mkdir -i $MDTIDX $tgt_dir
2154
2155         dd if=/etc/hosts of=$src_dir/src_file
2156         touch $tgt_dir/tgt_file
2157         drop_update_reply $MDTIDX \
2158                 "mrename $src_dir/src_file $tgt_dir/tgt_file" ||
2159                 error "mrename failed"
2160
2161         $CHECKSTAT -t file $src_dir/src_file &&
2162                                 error "src_file present after rename"
2163
2164         diff /etc/hosts $tgt_dir/tgt_file ||
2165                         error "file changed after rename"
2166
2167 }
2168 run_test 110h "drop update reply during cross-MDT file rename"
2169
2170 test_110i () {
2171         [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
2172         local src_dir=$DIR/$tdir/source_dir
2173         local tgt_dir=$DIR/$tdir/target_dir
2174         local MDTIDX=1
2175
2176         mkdir -p $src_dir
2177         $LFS mkdir -i $MDTIDX $tgt_dir
2178
2179         mkdir $src_dir/src_dir
2180         touch $src_dir/src_dir/a
2181         mkdir $tgt_dir/tgt_dir
2182         drop_update_reply $MDTIDX \
2183                 "mrename $src_dir/src_dir $tgt_dir/tgt_dir" ||
2184                 error "mrename failed"
2185
2186         $CHECKSTAT -t dir $src_dir/src_dir &&
2187                         error "src_dir present after rename"
2188
2189         $CHECKSTAT -t dir $tgt_dir/tgt_dir ||
2190                                 error "tgt_dir not present after rename"
2191
2192         $CHECKSTAT -t file $tgt_dir/tgt_dir/a ||
2193                                 error "a not present after rename"
2194 }
2195 run_test 110i "drop update reply during cross-MDT dir rename"
2196
2197 test_110j () {
2198         [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
2199         local remote_dir=$DIR/$tdir/remote_dir
2200         local local_dir=$DIR/$tdir/local_dir
2201         local MDTIDX=1
2202
2203         mkdir -p $DIR/$tdir
2204         mkdir $DIR/$tdir/local_dir
2205         $LFS mkdir -i $MDTIDX $remote_dir
2206
2207         touch $local_dir/local_file
2208         drop_update_reply $MDTIDX \
2209                 "ln $local_dir/local_file $remote_dir/remote_file" ||
2210                 error "ln failed"
2211
2212         $CHECKSTAT -t file $remote_dir/remote_file ||
2213                                 error "remote not present after ln"
2214 }
2215 run_test 110j "drop update reply during cross-MDT ln"
2216
2217 # LU-2844 mdt prepare fail should not cause umount oops
2218 test_111 ()
2219 {
2220         [[ $(lustre_version_code $SINGLEMDS) -ge $(version_code 2.3.62) ]] ||
2221                 { skip "Need MDS version at least 2.3.62"; return 0; }
2222
2223         local mdsdev=$(mdsdevname ${SINGLEMDS//mds/})
2224 #define OBD_FAIL_MDS_CHANGELOG_INIT 0x151
2225         do_facet $SINGLEMDS lctl set_param fail_loc=0x151
2226         stop $SINGLEMDS || error "stop MDS failed"
2227         start $SINGLEMDS $mdsdev && error "start MDS should fail"
2228         do_facet $SINGLEMDS lctl set_param fail_loc=0
2229         start $SINGLEMDS $mdsdev || error "start MDS failed"
2230 }
2231 run_test 111 "mdd setup fail should not cause umount oops"
2232
2233 # LU-793
2234 test_112a() {
2235         remote_ost_nodsh && skip "remote OST with nodsh" && return 0
2236
2237         do_facet_random_file client $TMP/$tfile 100K ||
2238                 error_noexit "Create random file $TMP/$tfile"
2239
2240         pause_bulk "cp $TMP/$tfile $DIR/$tfile" $TIMEOUT ||
2241                 error_noexit "Can't pause_bulk copy"
2242
2243         df $DIR
2244         # expect cmp to succeed, client resent bulk
2245         cmp $TMP/$tfile $DIR/$tfile ||
2246                 error_noexit "Wrong data has been written"
2247         rm $DIR/$tfile ||
2248                 error_noexit "Can't remove file"
2249         rm $TMP/$tfile
2250 }
2251 run_test 112a "bulk resend while orignal request is in progress"
2252
2253 test_115_read() {
2254         local fail1=$1
2255         local fail2=$2
2256
2257         df $DIR
2258         dd if=/dev/zero of=$DIR/$tfile bs=4096 count=1
2259         cancel_lru_locks osc
2260
2261         # OST_READ       =  3,
2262         $LCTL set_param fail_loc=$fail1 fail_val=3
2263         dd of=/dev/null if=$DIR/$tfile bs=4096 count=1 &
2264         pid=$!
2265         sleep 1
2266
2267         set_nodes_failloc "$(osts_nodes)" $fail2
2268
2269         wait $pid || error "dd failed"
2270         return 0
2271 }
2272
2273 test_115_write() {
2274         local fail1=$1
2275         local fail2=$2
2276         local error=$3
2277         local fail_val2=${4:-0}
2278
2279         df $DIR
2280         touch $DIR/$tfile
2281
2282         # OST_WRITE      =  4,
2283         $LCTL set_param fail_loc=$fail1 fail_val=4
2284         dd if=/dev/zero of=$DIR/$tfile bs=4096 count=1 oflag=dsync &
2285         pid=$!
2286         sleep 1
2287
2288         df $MOUNT
2289         set_nodes_failloc "$(osts_nodes)" $fail2 $fail_val2
2290
2291         wait $pid
2292         rc=$?
2293         [ $error -eq 0 ] && [ $rc -ne 0 ] && error "dd error ($rc)"
2294         [ $error -ne 0 ] && [ $rc -eq 0 ] && error "dd success"
2295         return 0
2296 }
2297
2298 test_115a() {
2299         [ $(lustre_version_code ost1) -lt $(version_code 2.8.50) ] &&
2300                 skip "need at least 2.8.50 on OST" && return 0
2301
2302         #define OBD_FAIL_PTLRPC_LONG_REQ_UNLINK  0x51b
2303         #define OBD_FAIL_PTLRPC_DROP_BULK        0x51a
2304         test_115_read 0x8000051b 0x8000051a
2305 }
2306 run_test 115a "read: late REQ MDunlink and no bulk"
2307
2308 test_115b() {
2309         [ $(lustre_version_code ost1) -lt $(version_code 2.8.50) ] &&
2310                 skip "need at least 2.8.50 on OST" && return 0
2311
2312         #define OBD_FAIL_PTLRPC_LONG_REQ_UNLINK  0x51b
2313         #define OBD_FAIL_OST_ENOSPC              0x215
2314
2315         # pass $OSTCOUNT for the fail_loc to be caught
2316         # appropriately by the IO thread
2317         test_115_write 0x8000051b 0x80000215 1 $OSTCOUNT
2318 }
2319 run_test 115b "write: late REQ MDunlink and no bulk"
2320
2321 test_115c() {
2322         [ $(lustre_version_code ost1) -lt $(version_code 2.8.50) ] &&
2323                 skip "need at least 2.8.50 on OST" && return 0
2324
2325         #define OBD_FAIL_PTLRPC_LONG_REPL_UNLINK 0x50f
2326         #define OBD_FAIL_PTLRPC_DROP_BULK        0x51a
2327         test_115_read 0x8000050f 0x8000051a
2328 }
2329 run_test 115c "read: late Reply MDunlink and no bulk"
2330
2331 test_115d() {
2332         [ $(lustre_version_code ost1) -lt $(version_code 2.8.50) ] &&
2333                 skip "need at least 2.8.50 on OST" && return 0
2334
2335         #define OBD_FAIL_PTLRPC_LONG_REPL_UNLINK 0x50f
2336         #define OBD_FAIL_OST_ENOSPC              0x215
2337         test_115_write 0x8000050f 0x80000215 0
2338 }
2339 run_test 115d "write: late Reply MDunlink and no bulk"
2340
2341 test_115e() {
2342         [ $(lustre_version_code ost1) -lt $(version_code 2.8.50) ] &&
2343                 skip "need at least 2.8.50 on OST" && return 0
2344
2345         #define OBD_FAIL_PTLRPC_LONG_BULK_UNLINK 0x510
2346         #define OBD_FAIL_OST_ALL_REPLY_NET       0x211
2347         test_115_read 0x80000510 0x80000211
2348 }
2349 run_test 115e "read: late Bulk MDunlink and no reply"
2350
2351 test_115f() {
2352         [ $(lustre_version_code ost1) -lt $(version_code 2.8.50) ] &&
2353                 skip "need at least 2.8.50 on OST" && return 0
2354
2355         #define OBD_FAIL_PTLRPC_LONG_REQ_UNLINK  0x51b
2356         #define OBD_FAIL_OST_ALL_REPLY_NET       0x211
2357         test_115_read 0x8000051b 0x80000211
2358 }
2359 run_test 115f "read: late REQ MDunlink and no reply"
2360
2361 test_115g() {
2362         [ $(lustre_version_code ost1) -lt $(version_code 2.8.50) ] &&
2363                 skip "need at least 2.8.50 on OST" && return 0
2364
2365         #define OBD_FAIL_PTLRPC_LONG_BOTH_UNLINK 0x51c
2366         test_115_read 0x8000051c 0
2367 }
2368 run_test 115g "read: late REQ MDunlink and Reply MDunlink"
2369
2370 # parameters: fail_loc CMD RC
2371 test_120_reply() {
2372         local PID
2373         local PID2
2374         local rc=5
2375         local fail
2376
2377         #define OBD_FAIL_LDLM_CP_CB_WAIT2       0x320
2378         #define OBD_FAIL_LDLM_CP_CB_WAIT3       0x321
2379         #define OBD_FAIL_LDLM_CP_CB_WAIT4       0x322
2380         #define OBD_FAIL_LDLM_CP_CB_WAIT5       0x323
2381
2382         echo
2383         echo -n "** FLOCK REPLY vs. EVICTION race, lock $2"
2384         [ "$1" = "CLEANUP" ] &&
2385                 fail=0x80000320 && echo ", $1 cp first"
2386         [ "$1" = "REPLY" ] &&
2387                 fail=0x80000321 && echo ", $1 cp first"
2388         [ "$1" = "DEADLOCK CLEANUP" ] &&
2389                 fail=0x80000322 && echo " DEADLOCK, CLEANUP cp first"
2390         [ "$1" = "DEADLOCK REPLY" ] &&
2391                 fail=0x80000323 && echo " DEADLOCK, REPLY cp first"
2392
2393         if [ x"$2" = x"get" ]; then
2394                 #for TEST lock, take a conflict in advance
2395                 # sleep longer than evictor to not confuse fail_loc: 2+2+4
2396                 echo "** Taking conflict **"
2397                 flocks_test 5 set read sleep 10 $DIR/$tfile &
2398                 PID2=$!
2399
2400                 sleep 2
2401         fi
2402
2403         $LCTL set_param fail_loc=$fail
2404
2405         flocks_test 5 $2 write $DIR/$tfile &
2406         PID=$!
2407
2408         sleep 2
2409         echo "** Evicting and re-connecting client **"
2410         mds_evict_client
2411
2412         client_reconnect
2413
2414         if [ x"$2" = x"get" ]; then
2415                 wait $PID2
2416         fi
2417
2418         wait $PID
2419         rc=$?
2420
2421         # check if the return value is allowed
2422         [ $rc -eq $3 ] && rc=0
2423
2424         $LCTL set_param fail_loc=0
2425         return $rc
2426 }
2427
2428 # a lock is taken, unlock vs. cleanup_resource() race for destroying
2429 # the ORIGINAL lock.
2430 test_120_destroy()
2431 {
2432         local PID
2433
2434         flocks_test 5 set write sleep 4 $DIR/$tfile &
2435         PID=$!
2436         sleep 2
2437
2438         # let unlock to sleep in CP CB
2439         $LCTL set_param fail_loc=$1
2440         sleep 4
2441
2442         # let cleanup to cleep in CP CB
2443         mds_evict_client
2444
2445         client_reconnect
2446
2447         wait $PID
2448         rc=$?
2449
2450         $LCTL set_param fail_loc=0
2451         return $rc
2452 }
2453
2454 test_120() {
2455         flock_is_enabled || { skip "mount w/o flock enabled" && return; }
2456         touch $DIR/$tfile
2457
2458         test_120_reply "CLEANUP" set 5 || error "SET race failed"
2459         test_120_reply "CLEANUP" get 5 || error "GET race failed"
2460         test_120_reply "CLEANUP" unlock 5 || error "UNLOCK race failed"
2461
2462         test_120_reply "REPLY" set 5 || error "SET race failed"
2463         test_120_reply "REPLY" get 5 || error "GET race failed"
2464         test_120_reply "REPLY" unlock 5 || error "UNLOCK race failed"
2465
2466         # DEADLOCK tests
2467         test_120_reply "DEADLOCK CLEANUP" set 5 || error "DEADLOCK race failed"
2468         test_120_reply "DEADLOCK REPLY" set 35 || error "DEADLOCK race failed"
2469
2470         test_120_destroy 0x320 || error "unlock-cleanup race failed"
2471 }
2472 run_test 120 "flock race: completion vs. evict"
2473
2474 test_113() {
2475         local BEFORE=$(date +%s)
2476         local EVICT
2477
2478         # modify dir so that next revalidate would not obtain UPDATE lock
2479         touch $DIR
2480
2481         # drop 1 reply with UPDATE lock,
2482         # resend should not create 2nd lock on server
2483         mcreate $DIR/$tfile || error "mcreate failed: $?"
2484         drop_ldlm_reply_once "stat $DIR/$tfile" || error "stat failed: $?"
2485
2486         # 2 BL AST will be sent to client, both must find the same lock,
2487         # race them to not get EINVAL for 2nd BL AST
2488         #define OBD_FAIL_LDLM_PAUSE_CANCEL2      0x31f
2489         $LCTL set_param fail_loc=0x8000031f
2490
2491         $LCTL set_param ldlm.namespaces.*.early_lock_cancel=0 > /dev/null
2492         chmod 0777 $DIR/$tfile || error "chmod failed: $?"
2493         $LCTL set_param ldlm.namespaces.*.early_lock_cancel=1 > /dev/null
2494
2495         # let the client reconnect
2496         client_reconnect
2497         EVICT=$($LCTL get_param mdc.$FSNAME-MDT*.state |
2498           awk -F"[ [,]" '/EVICTED ]$/ { if (mx<$5) {mx=$5;} } END { print mx }')
2499
2500         [ -z "$EVICT" ] || [[ $EVICT -le $BEFORE ]] || error "eviction happened"
2501 }
2502 run_test 113 "ldlm enqueue dropped reply should not cause deadlocks"
2503
2504 T130_PID=0
2505 test_130_base() {
2506         test_mkdir -p $DIR/$tdir
2507
2508         # Prevent interference from layout intent RPCs due to
2509         # asynchronous writeback. These will be tested in 130c below.
2510         do_nodes ${CLIENTS:-$HOSTNAME} sync
2511
2512         # get only LOOKUP lock on $tdir
2513         cancel_lru_locks mdc
2514         ls $DIR/$tdir/$tfile 2>/dev/null
2515
2516         # get getattr by fid on $tdir
2517         #
2518         # we need to race with unlink, unlink must complete before we will
2519         # take a DLM lock, otherwise unlink will wait until getattr will
2520         # complete; but later than getattr starts so that getattr found
2521         # the object
2522 #define OBD_FAIL_MDS_INTENT_DELAY               0x160
2523         set_nodes_failloc "$(mdts_nodes)" 0x80000160
2524         stat $DIR/$tdir &
2525         T130_PID=$!
2526         sleep 2
2527
2528         rm -rf $DIR/$tdir
2529
2530         # drop the reply so that resend happens on an unlinked file.
2531 #define OBD_FAIL_MDS_LDLM_REPLY_NET      0x157
2532         set_nodes_failloc "$(mdts_nodes)" 0x80000157
2533 }
2534
2535 test_130a() {
2536         remote_mds_nodsh && skip "remote MDS with nodsh" && return
2537         local server_version=$(lustre_version_code $SINGLEMDS)
2538         [[ $server_version -ge $(version_code 2.7.2) ]] ||
2539                 { skip "Need server version newer than 2.7.1"; return 0; }
2540
2541         test_130_base
2542
2543         wait $T130_PID || [ $? -eq 0 ] && error "stat should fail"
2544         return 0
2545 }
2546 run_test 130a "enqueue resend on not existing file"
2547
2548 test_130b() {
2549         remote_mds_nodsh && skip "remote MDS with nodsh" && return
2550         local server_version=$(lustre_version_code $SINGLEMDS)
2551         [[ $server_version -ge $(version_code 2.7.2) ]] ||
2552                 { skip "Need server version newer than 2.7.1"; return 0; }
2553
2554         test_130_base
2555         # let the reply to be dropped
2556         sleep 10
2557
2558 #define OBD_FAIL_SRV_ENOENT              0x217
2559         set_nodes_failloc "$(mdts_nodes)" 0x80000217
2560
2561         wait $T130_PID || [ $? -eq 0 ] && error "stat should fail"
2562         return 0
2563 }
2564 run_test 130b "enqueue resend on a stale inode"
2565
2566 test_130c() {
2567         remote_mds_nodsh && skip "remote MDS with nodsh" && return
2568
2569         do_nodes ${CLIENTS:-$HOSTNAME} sync
2570         echo XXX > $DIR/$tfile
2571
2572         cancel_lru_locks mdc
2573
2574         # Trigger writeback on $tfile.
2575         #
2576         # we need to race with unlink, unlink must complete before we will
2577         # take a DLM lock, otherwise unlink will wait until intent will
2578         # complete; but later than intent starts so that intent found
2579         # the object
2580 #define OBD_FAIL_MDS_INTENT_DELAY               0x160
2581         set_nodes_failloc "$(mdts_nodes)" 0x80000160
2582         sync &
2583         T130_PID=$!
2584         sleep 2
2585
2586         rm $DIR/$tfile
2587
2588         # drop the reply so that resend happens on an unlinked file.
2589 #define OBD_FAIL_MDS_LDLM_REPLY_NET      0x157
2590         set_nodes_failloc "$(mdts_nodes)" 0x80000157
2591
2592         # let the reply to be dropped
2593         sleep 10
2594
2595 #define OBD_FAIL_SRV_ENOENT              0x217
2596         set_nodes_failloc "$(mdts_nodes)" 0x80000217
2597
2598         wait $T130_PID
2599
2600         return 0
2601 }
2602 run_test 130c "layout intent resend on a stale inode"
2603
2604 test_132() {
2605         local before=$(date +%s)
2606         local evict
2607
2608         mount_client $MOUNT2 || error "mount filed"
2609
2610         rm -f $DIR/$tfile
2611         # get a lock on client so that export would reach the stale list
2612         $SETSTRIPE -i 0 $DIR/$tfile || error "setstripe failed"
2613         dd if=/dev/zero of=$DIR/$tfile bs=4096 count=1 conv=fsync ||
2614                 error "dd failed"
2615
2616         #define OBD_FAIL_OST_PAUSE_PUNCH         0x236
2617         do_facet ost1 $LCTL set_param fail_val=120 fail_loc=0x80000236
2618
2619         $TRUNCATE $DIR/$tfile 100 &
2620
2621         sleep 1
2622         dd if=/dev/zero of=$DIR2/$tfile bs=4096 count=1 conv=notrunc ||
2623                 error "dd failed"
2624
2625         wait
2626         umount_client $MOUNT2
2627
2628         evict=$(do_facet client $LCTL get_param \
2629                 osc.$FSNAME-OST0000-osc-*/state |
2630             awk -F"[ [,]" '/EVICTED ]$/ { if (t<$5) {t=$5;} } END { print t }')
2631
2632         [ -z "$evict" ] || [[ $evict -le $before ]] ||
2633                 (do_facet client $LCTL get_param \
2634                         osc.$FSNAME-OST0000-osc-*/state;
2635                     error "eviction happened: $evict before:$before")
2636 }
2637 run_test 132 "long punch"
2638
2639 test_131() {
2640         remote_ost_nodsh && skip "remote OST with nodsh" && return 0
2641
2642         rm -f $DIR/$tfile
2643         # get a lock on client so that export would reach the stale list
2644         $SETSTRIPE -i 0 $DIR/$tfile || error "setstripe failed"
2645         dd if=/dev/zero of=$DIR/$tfile count=1 || error "dd failed"
2646
2647         # another IO under the same lock
2648         #define OBD_FAIL_OSC_DELAY_IO            0x414
2649         $LCTL set_param fail_loc=0x80000414
2650         $LCTL set_param fail_val=4 fail_loc=0x80000414
2651         dd if=/dev/zero of=$DIR/$tfile count=1 conv=notrunc oflag=dsync &
2652         local pid=$!
2653         sleep 1
2654
2655         #define OBD_FAIL_LDLM_BL_EVICT           0x31e
2656         set_nodes_failloc "$(osts_nodes)" 0x8000031e
2657         ost_evict_client
2658         client_reconnect
2659
2660         wait $pid && error "dd succeeded"
2661         return 0
2662 }
2663 run_test 131 "IO vs evict results to IO under staled lock"
2664
2665 test_133() {
2666         local list=$(comma_list $(mdts_nodes))
2667
2668         local t=$((TIMEOUT * 2))
2669         touch $DIR/$tfile
2670
2671         flock $DIR/$tfile -c "echo bl lock;sleep $t;echo bl flock unlocked" &
2672         sleep 1
2673         multiop_bg_pause $DIR/$tfile O_jc || return 1
2674         PID=$!
2675
2676         #define OBD_FAIL_LDLM_REPLY              0x30c
2677         do_nodes $list $LCTL set_param fail_loc=0x8000030c
2678         kill -USR1 $PID
2679         echo "waiting for multiop $PID"
2680         wait $PID || return 2
2681
2682         rm -f $DIR/$tfile
2683
2684         return 0
2685 }
2686 run_test 133 "don't fail on flock resend"
2687
2688 complete $SECONDS
2689 check_and_cleanup_lustre
2690 exit_status